import os

from ccp.general.Io import getDataPath

pulProgFile = getDataPath('ccp', 'bruker', 'Pulprog.info')

#
# THIS HAS TO BECOME TEXT FILE!!
#

# THIS NOT USED YET!
mappingToCcpn = {

'hnco': 'H[N[CO]]',  # Experiment name - can find pathway by looping over all pathways and looking for this name.
                     # Then need dimension information... WARNING what about reversed dimension stuff?
                     # In case of hnco, would this generally be F1:1,F3:2,F2:3 (but AQSEQ? Can change?)

#
# For automatic mapping, almost have to read in experiment itself, then compare to possible pathway info
# in Bruker pulse sequence to match up... then also need mapping between atom names (CO->C=O) though.
#

}

stdExpNameDict = {
               'adeq':     'ADEQUATE',
               'apt':      'APT (attached proton test)',
               'aring':    'Anti-ring',
               'atocsy':   'Adiabatic TOCSY',
               '^b_':       'Best sequence (Brutscher)',
               '^c_':       'Carbon detected experiment', 
               'c6':       'Nucleic acid atom',
               'h56c56c4n3h': 'Nucleic acid atoms',
               'h5c5c4n3h':   'Nucleic acid atoms',
               'h68c68n19c42':'Nucleic acid atoms',
               'cac':      '',
               'caco':     '',
               'cacon':    '',
               'calib':    'Calibration',
               'can':      '',
               'canco':    '',
               'cbcaco':   'CBCACO',
               'cbcacon':  'CBCACON',
               'cbcaconh': 'CBCACONH',
               'cbcanco':   '',
               'cbcanh':   'CBCANH',
               'cbcgcd':   '',
               'cbcgcehe': '',
               'ccaconh':  'CCACONH',
               'ccanh':    'CCANH',
               'ccco':     '',
               'cccon':    '',
               'ccconh':   '',
               'clmlev':   'Clean MLEV - TOCSY',
               'coca':     '',
               'coloc':    '',
               'con':      '',
               'conh':     '',
               'cosy':     'COSY',
               'cpmg':     'CPMG - T2 type',
               'crinept':  'CRINEPT (TROSY)',
               'croesy':   'CROESY - compensated (no TOCSY)',
               'daz':      'DANTE-Z',
               'dec':      'Decoupled pulse calib',
               'decp':     'Decoupled pulse calib (see dec)',
               'dept':     'DEPT',
               'deptq':    'DEPT + quaternary carbons',
               'dif':      'difference',
               'diff':     'difference',
               'dipsi':    'DIPSI',
               'dipsi2':   'TOCSY',
               'dqs':      'double quantum spectroscopy',
               'dste':     'Double stimulated echo',
               'ecos':     'E-COSY variant',
               'ecosy':    'E-COSY',
               'eretic':   'ERETIC',
               'fhsqc':    'Fast HSQC',
               'flopsy16': 'TOCSY',
               'ghcch':    'Gamma-HCCH',
               'h2bc':     'H2BC',
               'hacaco':   '',
               'hacahb':   '',
               'haconh':   '',
               'hanh':     '',
               'hathmbc':  'HAT-HMBC',
               'hbhanh':   '',
               'hbcbcgcdcehe': '',
               'hbcbcgcdhd':'',
               'hbhaconh': '',
               '*hc':      '',
               'hcaco':    '',
               'hcacon':   '',
               'hcan':     '',
               'hcanco':   '',
               'hcannh':   '',
               'hcbca':    '',
               'hcbcaco':  '',
               'hcbcan':   '',
               'hcbcacon': '',
               'hcc':      '',
               'hccconh':  '',
               'hcch':     '',
               'hcchco':   '',
               'hccnh':    'Nucleic acid atoms',
               '^hccc':    '',
               'hcn':     '',
               'hcncch':   'Nucleic acid atoms',
               'hcnch':    'Nucleic acid atoms',
               'hcnh':     'Nucleic acid atoms',
               'hcp':      'Nucleic acid atoms',
               'hcpq':     'Nucleic acid atoms, quantitative',
               'hfco':     'Proton-fluor',
               'hhxco':    'H relayed H X-COSY',
               'hjres':    'Heteronuclear J res',
               'hmbc':     'HMBC',
               'hmbcac':   'HMBC for CAC',   # Necessary because otherwise name problem
               'hmbcacb':  'HMBC for CACB',  # Necessary because otherwise name problem
               #'hmbcacg':  'HMBC for CACG',  # Necessary because otherwise name problem
               'hmqc':     'HMQC',
               'hmqcj':    'HMQC',
               'hmsc':     'Heternuclear multiple single bond correlation',
               'hnc6c5':   'Nucleic acid atoms',
               'hnca':     'HNCA',
               'hncac':    'HNCAC',
               'hncacb':   'HNCACB',
               'hncaco':   'HNCACO',
               'hncah':    '',
               'hncaha':   '',
               'hncannh':  '',
               'hncch':    'Nucleic acid atoms',
               'hncg':     '',
               'hnco':     'HNCO',
               'hncoc':    'HNCOC',
               'hncoca':   'HNCOCA',
               'hncocac':  'HNCOCAC',
               'hncocaca': 'HNCOCACA',
               'hncocacb': 'HNCOCACB',
               'hncocanh': 'HNCOCANH',
               'hncoco':   'HNCOCO',
               'hnh':      'HNH',
               'hnha':     'HNHA',
               'hnhb':     'HNHB',
               'hnnco':    'HNNCO',
               'hnnh':     'HNNH',
               'hoesy':    'Heteronuclear Overhauser...',
               'hpc':      'Nucleic acid atoms',
               'hpct':     'Nucleic acid atoms',
               'hpcco':    'Nucleic acid atoms',
               'hpcosy':   'Proton phosphor COSY',
               'hsqc':     'HSQC',
               'hxco':     'Proton-X correlation',
               'hxdept':   'Proton-X corr using DEPT',
               'hxinep':   'Proton-X corr using INEPT',
               'hxxco':    'Proton-X-X correlation',
               'idept':    'Inverse DEPT',
               'iinept':   'Inverse INEPT',
               'ina':      'INADEQUATE',
               'inad':     'INADEQUATE',
               'indeco':   'Inverse DEPT COSY',
               'inepin':   'INEPT-INADEQUATE',
               'inept':    'INEPT',
               'ineptp':   'INEPT plus',
               '^im':       'Imaging (used for gradient shimming)', # This signifies ONLY at start of string!
               'imrcb':    'Imaging RCB',
               'jmod':     'J-modulation',
               'jres':     'J-resolution',
               'lc1':      'LC nmr, 1d',
               'lc2':      'LC nmr, 2d',
               'lc':       'LC nmr, generic',
               'led':      'LED (diffusion exp)',
               'mlev':     'TOCSY',
               'music':    'MUSIC',   # Is special case - have to get amino acid names out of pulse prog name
               'mqs':      'Multiple quantum spectroscopy',
               'noe':      'NOESY',
               'noemul':   'Multiple NOE difference',
               'noesy':    'NOESY',
               '^na_':     'Nucleic Acid',
               '^na_hp':   'Nucleic acid atoms',
               '^na_hpc':  'Nucleic acid atoms',
               '^na_hcn':  'Nucleic acid atoms',
               '^na_hcncch':'Nucleic acid atoms',
               '^na_hcnch':'Nucleic acid atoms',
               '^na_hcnh': 'Nucleic acid atoms',
               '^na_hcp':  'Nucleic acid atoms',
               '^na_hcpq': 'Nucleic acid atoms, qualitative',
               'p11':      'Jump return',
               'p1331':    'Jump return',
               'p3919':    'Watergate',
               'pcch':     'Nucleic acid atoms',
               'pfids':    'PFIDS',
               'preemp':   'Pre-emphasis',
               'quat':     'Quaternary carbon only',
               'rd_':      'Reduced dimensionality',
               'roesy':    'ROESY',
               'rex':      'Relaxation rate exchange',
               'scosy':    'Semi-selective cosy',
               'secsy':    'SECSY',
               'sel':      'Selective',
               'seq':      'Sequential triple resonance',
               'sfhmqc':   'So-fast HMQC',
               'shmbc':    'Semi-selective HMBC',
               'std':      'Saturation transfer difference',
               'ste':      'Stimulated echo',
               't1':       'T1 relaxation',
               't1ir':     'T1 relaxation with inverse recovery',
               't2':       'T2 relaxation',
               'tocsy':    'TOCSY',
               '^tr':      'TROSY',
               'troesy':   'Tilted ROESY',
               'trosy':    'TROSY',
               'udeft':    'UDEFT',
               'wet':      'WET (water supression)',
               'xhco':     'X-proton correlation',
               'zg':       'Zero and GO!',
               'zg0':      'Zero and GO!',
               'zgadc':    'Zg with explicit acquistion programming',
              }
