"""
#######################################################################

CCPN Data Model version 2.1.2

Autogenerated by PyXmlMapWrite revision 1.29 on Mon Mar  2 17:24:09 2015
  from data model element ccp.general.Citation revision ?

#######################################################################
======================COPYRIGHT/LICENSE START==========================

Citation.py: python XML-I/O-mapping for CCPN data model, MetaPackage ccp.general.Citation

Copyright (C) 2007  (CCPN Project)

=======================================================================

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.
 
A copy of this license can be found in ../../../../license/LGPL.license
 
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
 
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


======================COPYRIGHT/LICENSE END============================

for further information, please contact :

- CCPN website (http://www.ccpn.ac.uk/)

- email: ccpn@bioc.cam.ac.uk

=======================================================================

If you are using this software for academic purposes, we suggest
quoting the following references:

===========================REFERENCE START=============================
Rasmus H. Fogh, Wayne Boucher, Wim F. Vranken, Anne
Pajon, Tim J. Stevens, T.N. Bhat, John Westbrook, John M.C. Ionides and
Ernest D. Laue (2005). A framework for scientific data modeling and automated
software development. Bioinformatics 21, 1678-1684.


This file was generated with the Memops software generation framework,
and contains original contributions embedded in the framework

===========================REFERENCE END===============================
"""
from memops.general.Constants import baseDataTypeModule as basicDataTypes
# 
#  Current package api
import ccp.api.general.Citation

def makeMapping(globalMap):
  """
  generates XML I/O mapping for package CITA, adding it to globalMap
  """
  
  from memops.xml.Implementation import bool2str, str2bool

  # Set up top level dictionaries
  loadMaps = globalMap.get('loadMaps')
  mapsByGuid = globalMap.get('mapsByGuid')

  abstractTypes = globalMap.get('CITA').get('abstractTypes')
  exolinks = globalMap.get('CITA').get('exolinks')

  # DataType CitationStatus
  currentMap = {}
  abstractTypes['CitationStatus'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00016'] = currentMap
  loadMaps['CITA.CitationStatus'] = currentMap
  currentMap['tag'] = 'CITA.CitationStatus'
  currentMap['type'] = 'simple'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00016'
  currentMap['toStr'] = 'text'
  currentMap['cnvrt'] = 'text'

  # Class Citation
  currentMap = {}
  abstractTypes['Citation'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00011'] = currentMap
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00011'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'citations'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.Citation.Citation
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute Citation.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute Citation.casAbstractCode
  currentMap = {}
  contentMap['casAbstractCode'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00014'] = currentMap
  loadMaps['CITA.Citation.casAbstractCode'] = currentMap
  currentMap['tag'] = 'CITA.Citation.casAbstractCode'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00014'
  currentMap['name'] = 'casAbstractCode'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute Citation.details
  currentMap = {}
  contentMap['details'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00020'] = currentMap
  loadMaps['CITA.Citation.details'] = currentMap
  currentMap['tag'] = 'CITA.Citation.details'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00020'
  currentMap['name'] = 'details'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute Citation.doi
  currentMap = {}
  contentMap['doi'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00013'] = currentMap
  loadMaps['CITA.Citation.doi'] = currentMap
  currentMap['tag'] = 'CITA.Citation.doi'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00013'
  currentMap['name'] = 'doi'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute Citation.firstPage
  currentMap = {}
  contentMap['firstPage'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00017'] = currentMap
  loadMaps['CITA.Citation.firstPage'] = currentMap
  currentMap['tag'] = 'CITA.Citation.firstPage'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00017'
  currentMap['name'] = 'firstPage'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute Citation.keywords
  currentMap = {}
  contentMap['keywords'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00010'] = currentMap
  loadMaps['CITA.Citation.keywords'] = currentMap
  currentMap['tag'] = 'CITA.Citation.keywords'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00010'
  currentMap['name'] = 'keywords'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute Citation.lastPage
  currentMap = {}
  contentMap['lastPage'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00018'] = currentMap
  loadMaps['CITA.Citation.lastPage'] = currentMap
  currentMap['tag'] = 'CITA.Citation.lastPage'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00018'
  currentMap['name'] = 'lastPage'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute Citation.medlineUiCode
  currentMap = {}
  contentMap['medlineUiCode'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00015'] = currentMap
  loadMaps['CITA.Citation.medlineUiCode'] = currentMap
  currentMap['tag'] = 'CITA.Citation.medlineUiCode'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00015'
  currentMap['name'] = 'medlineUiCode'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute Citation.pubMedId
  currentMap = {}
  contentMap['pubMedId'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00016'] = currentMap
  loadMaps['CITA.Citation.pubMedId'] = currentMap
  currentMap['tag'] = 'CITA.Citation.pubMedId'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00016'
  currentMap['name'] = 'pubMedId'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute Citation.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00009'] = currentMap
  loadMaps['CITA.Citation.serial'] = currentMap
  currentMap['tag'] = 'CITA.Citation.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00009'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute Citation.status
  currentMap = {}
  contentMap['status'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00012'] = currentMap
  loadMaps['CITA.Citation.status'] = currentMap
  currentMap['tag'] = 'CITA.Citation.status'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00012'
  currentMap['name'] = 'status'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00016')

  # Attribute Citation.title
  currentMap = {}
  contentMap['title'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00011'] = currentMap
  loadMaps['CITA.Citation.title'] = currentMap
  currentMap['tag'] = 'CITA.Citation.title'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00011'
  currentMap['name'] = 'title'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00005')

  # Attribute Citation.year
  currentMap = {}
  contentMap['year'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00019'] = currentMap
  loadMaps['CITA.Citation.year'] = currentMap
  currentMap['tag'] = 'CITA.Citation.year'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00019'
  currentMap['name'] = 'year'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['proc'] = 'direct'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Role Citation.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role Citation.authors
  currentMap = {}
  contentMap['authors'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00002'] = currentMap
  loadMaps['CITA.Citation.authors'] = currentMap
  currentMap['tag'] = 'CITA.Citation.authors'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00002'
  currentMap['name'] = 'authors'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('AFFI').get('exolinks')

  # Role Citation.editors
  currentMap = {}
  contentMap['editors'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00004'] = currentMap
  loadMaps['CITA.Citation.editors'] = currentMap
  currentMap['tag'] = 'CITA.Citation.editors'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00004'
  currentMap['name'] = 'editors'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('AFFI').get('exolinks')
  # End of Citation

  currentMap = abstractTypes.get('Citation')
  aList = ['serial', 'year']
  currentMap['headerAttrs'] = aList
  aList = ['casAbstractCode', 'details', 'doi', 'firstPage', 'keywords', 'lastPage', 'medlineUiCode', 'pubMedId', 'status', 'title']
  currentMap['simpleAttrs'] = aList
  aList = ['editors', 'authors', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class CitationStore
  currentMap = {}
  abstractTypes['CitationStore'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00017'] = currentMap
  loadMaps['CITA.CitationStore'] = currentMap
  currentMap['tag'] = 'CITA.CitationStore'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00017'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'citationStores'
  currentMap['isTop'] = True
  currentMap['objkey'] = 'name'
  currentMap['class'] = ccp.api.general.Citation.CitationStore
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute CitationStore.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute CitationStore.createdBy
  contentMap['createdBy'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:00:59_00002__www.ccpn.ac.uk_Fogh_2007-10-03-14:53:27_00001__www.ccpn.ac.uk_Fogh_2006-09-14-16:28:57_00002')

  # Attribute CitationStore.guid
  contentMap['guid'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:26_00002')

  # Attribute CitationStore.isModifiable
  contentMap['isModifiable'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-17-14:16:26_00010__www.ccpn.ac.uk_Fogh_2007-10-03-14:53:27_00001__www.ccpn.ac.uk_Fogh_2006-09-14-16:28:57_00002')

  # Attribute CitationStore.lastUnlockedBy
  contentMap['lastUnlockedBy'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:00:59_00003__www.ccpn.ac.uk_Fogh_2007-10-03-14:53:27_00001__www.ccpn.ac.uk_Fogh_2006-09-14-16:28:57_00002')

  # Attribute CitationStore.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00048'] = currentMap
  loadMaps['CITA.CitationStore.name'] = currentMap
  currentMap['tag'] = 'CITA.CitationStore.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00048'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Role CitationStore.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role CitationStore.citations
  currentMap = {}
  contentMap['citations'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00047'] = currentMap
  loadMaps['CITA.CitationStore.citations'] = currentMap
  currentMap['tag'] = 'CITA.CitationStore.citations'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00047'
  currentMap['name'] = 'citations'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('CITA').get('abstractTypes')
  # End of CitationStore

  currentMap = abstractTypes.get('CitationStore')
  aList = ['createdBy', 'guid', 'isModifiable', 'lastUnlockedBy']
  currentMap['headerAttrs'] = aList
  aList = ['name']
  currentMap['simpleAttrs'] = aList
  aList = ['citations', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['citations']
  currentMap['children'] = aList

  # Class JournalCitation
  currentMap = {}
  abstractTypes['JournalCitation'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00015'] = currentMap
  loadMaps['CITA.JournalCitation'] = currentMap
  currentMap['tag'] = 'CITA.JournalCitation'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00015'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'citations'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.Citation.JournalCitation
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute JournalCitation.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute JournalCitation.astm
  currentMap = {}
  contentMap['astm'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00043'] = currentMap
  loadMaps['CITA.JournalCitation.astm'] = currentMap
  currentMap['tag'] = 'CITA.JournalCitation.astm'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00043'
  currentMap['name'] = 'astm'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute JournalCitation.casAbstractCode
  contentMap['casAbstractCode'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00014')

  # Attribute JournalCitation.csd
  currentMap = {}
  contentMap['csd'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00045'] = currentMap
  loadMaps['CITA.JournalCitation.csd'] = currentMap
  currentMap['tag'] = 'CITA.JournalCitation.csd'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00045'
  currentMap['name'] = 'csd'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute JournalCitation.details
  contentMap['details'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00020')

  # Attribute JournalCitation.doi
  contentMap['doi'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00013')

  # Attribute JournalCitation.firstPage
  contentMap['firstPage'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00017')

  # Attribute JournalCitation.issn
  currentMap = {}
  contentMap['issn'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00044'] = currentMap
  loadMaps['CITA.JournalCitation.issn'] = currentMap
  currentMap['tag'] = 'CITA.JournalCitation.issn'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00044'
  currentMap['name'] = 'issn'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute JournalCitation.issue
  currentMap = {}
  contentMap['issue'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00042'] = currentMap
  loadMaps['CITA.JournalCitation.issue'] = currentMap
  currentMap['tag'] = 'CITA.JournalCitation.issue'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00042'
  currentMap['name'] = 'issue'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute JournalCitation.journalAbbreviation
  currentMap = {}
  contentMap['journalAbbreviation'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00039'] = currentMap
  loadMaps['CITA.JournalCitation.journalAbbreviation'] = currentMap
  currentMap['tag'] = 'CITA.JournalCitation.journalAbbreviation'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00039'
  currentMap['name'] = 'journalAbbreviation'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute JournalCitation.journalFullName
  currentMap = {}
  contentMap['journalFullName'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00040'] = currentMap
  loadMaps['CITA.JournalCitation.journalFullName'] = currentMap
  currentMap['tag'] = 'CITA.JournalCitation.journalFullName'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00040'
  currentMap['name'] = 'journalFullName'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute JournalCitation.keywords
  contentMap['keywords'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00010')

  # Attribute JournalCitation.lastPage
  contentMap['lastPage'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00018')

  # Attribute JournalCitation.medlineUiCode
  contentMap['medlineUiCode'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00015')

  # Attribute JournalCitation.pubMedId
  contentMap['pubMedId'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00016')

  # Attribute JournalCitation.serial
  contentMap['serial'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00009')

  # Attribute JournalCitation.status
  contentMap['status'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00012')

  # Attribute JournalCitation.title
  contentMap['title'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00011')

  # Attribute JournalCitation.volume
  currentMap = {}
  contentMap['volume'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00041'] = currentMap
  loadMaps['CITA.JournalCitation.volume'] = currentMap
  currentMap['tag'] = 'CITA.JournalCitation.volume'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00041'
  currentMap['name'] = 'volume'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute JournalCitation.year
  contentMap['year'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00019')

  # Role JournalCitation.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role JournalCitation.authors
  contentMap['authors'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00002')

  # Role JournalCitation.editors
  contentMap['editors'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00004')
  # End of JournalCitation

  currentMap = abstractTypes.get('JournalCitation')
  aList = ['serial', 'year']
  currentMap['headerAttrs'] = aList
  aList = ['astm', 'casAbstractCode', 'csd', 'details', 'doi', 'firstPage', 'issn', 'issue', 'journalAbbreviation', 'journalFullName', 'keywords', 'lastPage', 'medlineUiCode', 'pubMedId', 'status', 'title', 'volume']
  currentMap['simpleAttrs'] = aList
  aList = ['editors', 'authors', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class ThesisCitation
  currentMap = {}
  abstractTypes['ThesisCitation'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00014'] = currentMap
  loadMaps['CITA.ThesisCitation'] = currentMap
  currentMap['tag'] = 'CITA.ThesisCitation'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00014'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'citations'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.Citation.ThesisCitation
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute ThesisCitation.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute ThesisCitation.casAbstractCode
  contentMap['casAbstractCode'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00014')

  # Attribute ThesisCitation.city
  currentMap = {}
  contentMap['city'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00036'] = currentMap
  loadMaps['CITA.ThesisCitation.city'] = currentMap
  currentMap['tag'] = 'CITA.ThesisCitation.city'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00036'
  currentMap['name'] = 'city'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute ThesisCitation.country
  currentMap = {}
  contentMap['country'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00038'] = currentMap
  loadMaps['CITA.ThesisCitation.country'] = currentMap
  currentMap['tag'] = 'CITA.ThesisCitation.country'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00038'
  currentMap['name'] = 'country'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute ThesisCitation.details
  contentMap['details'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00020')

  # Attribute ThesisCitation.doi
  contentMap['doi'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00013')

  # Attribute ThesisCitation.firstPage
  contentMap['firstPage'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00017')

  # Attribute ThesisCitation.institution
  currentMap = {}
  contentMap['institution'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00035'] = currentMap
  loadMaps['CITA.ThesisCitation.institution'] = currentMap
  currentMap['tag'] = 'CITA.ThesisCitation.institution'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00035'
  currentMap['name'] = 'institution'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute ThesisCitation.keywords
  contentMap['keywords'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00010')

  # Attribute ThesisCitation.lastPage
  contentMap['lastPage'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00018')

  # Attribute ThesisCitation.medlineUiCode
  contentMap['medlineUiCode'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00015')

  # Attribute ThesisCitation.pubMedId
  contentMap['pubMedId'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00016')

  # Attribute ThesisCitation.serial
  contentMap['serial'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00009')

  # Attribute ThesisCitation.stateProvince
  currentMap = {}
  contentMap['stateProvince'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00037'] = currentMap
  loadMaps['CITA.ThesisCitation.stateProvince'] = currentMap
  currentMap['tag'] = 'CITA.ThesisCitation.stateProvince'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00037'
  currentMap['name'] = 'stateProvince'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute ThesisCitation.status
  contentMap['status'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00012')

  # Attribute ThesisCitation.title
  contentMap['title'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00011')

  # Attribute ThesisCitation.year
  contentMap['year'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00019')

  # Role ThesisCitation.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role ThesisCitation.authors
  contentMap['authors'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00002')

  # Role ThesisCitation.editors
  contentMap['editors'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00004')
  # End of ThesisCitation

  currentMap = abstractTypes.get('ThesisCitation')
  aList = ['serial', 'year']
  currentMap['headerAttrs'] = aList
  aList = ['casAbstractCode', 'city', 'country', 'details', 'doi', 'firstPage', 'institution', 'keywords', 'lastPage', 'medlineUiCode', 'pubMedId', 'stateProvince', 'status', 'title']
  currentMap['simpleAttrs'] = aList
  aList = ['editors', 'authors', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class ConferenceCitation
  currentMap = {}
  abstractTypes['ConferenceCitation'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00013'] = currentMap
  loadMaps['CITA.ConferenceCitation'] = currentMap
  currentMap['tag'] = 'CITA.ConferenceCitation'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00013'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'citations'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.Citation.ConferenceCitation
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute ConferenceCitation.abstractNumber
  currentMap = {}
  contentMap['abstractNumber'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00034'] = currentMap
  loadMaps['CITA.ConferenceCitation.abstractNumber'] = currentMap
  currentMap['tag'] = 'CITA.ConferenceCitation.abstractNumber'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00034'
  currentMap['name'] = 'abstractNumber'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute ConferenceCitation.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute ConferenceCitation.casAbstractCode
  contentMap['casAbstractCode'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00014')

  # Attribute ConferenceCitation.city
  currentMap = {}
  contentMap['city'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00029'] = currentMap
  loadMaps['CITA.ConferenceCitation.city'] = currentMap
  currentMap['tag'] = 'CITA.ConferenceCitation.city'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00029'
  currentMap['name'] = 'city'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute ConferenceCitation.conferenceSite
  currentMap = {}
  contentMap['conferenceSite'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00028'] = currentMap
  loadMaps['CITA.ConferenceCitation.conferenceSite'] = currentMap
  currentMap['tag'] = 'CITA.ConferenceCitation.conferenceSite'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00028'
  currentMap['name'] = 'conferenceSite'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute ConferenceCitation.conferenceTitle
  currentMap = {}
  contentMap['conferenceTitle'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00027'] = currentMap
  loadMaps['CITA.ConferenceCitation.conferenceTitle'] = currentMap
  currentMap['tag'] = 'CITA.ConferenceCitation.conferenceTitle'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00027'
  currentMap['name'] = 'conferenceTitle'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute ConferenceCitation.country
  currentMap = {}
  contentMap['country'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00031'] = currentMap
  loadMaps['CITA.ConferenceCitation.country'] = currentMap
  currentMap['tag'] = 'CITA.ConferenceCitation.country'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00031'
  currentMap['name'] = 'country'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute ConferenceCitation.details
  contentMap['details'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00020')

  # Attribute ConferenceCitation.doi
  contentMap['doi'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00013')

  # Attribute ConferenceCitation.endDate
  currentMap = {}
  contentMap['endDate'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00033'] = currentMap
  loadMaps['CITA.ConferenceCitation.endDate'] = currentMap
  currentMap['tag'] = 'CITA.ConferenceCitation.endDate'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00033'
  currentMap['name'] = 'endDate'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['proc'] = 'direct'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00029')

  # Attribute ConferenceCitation.firstPage
  contentMap['firstPage'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00017')

  # Attribute ConferenceCitation.keywords
  contentMap['keywords'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00010')

  # Attribute ConferenceCitation.lastPage
  contentMap['lastPage'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00018')

  # Attribute ConferenceCitation.medlineUiCode
  contentMap['medlineUiCode'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00015')

  # Attribute ConferenceCitation.pubMedId
  contentMap['pubMedId'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00016')

  # Attribute ConferenceCitation.serial
  contentMap['serial'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00009')

  # Attribute ConferenceCitation.startDate
  currentMap = {}
  contentMap['startDate'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00032'] = currentMap
  loadMaps['CITA.ConferenceCitation.startDate'] = currentMap
  currentMap['tag'] = 'CITA.ConferenceCitation.startDate'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00032'
  currentMap['name'] = 'startDate'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['proc'] = 'direct'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00029')

  # Attribute ConferenceCitation.stateProvince
  currentMap = {}
  contentMap['stateProvince'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00030'] = currentMap
  loadMaps['CITA.ConferenceCitation.stateProvince'] = currentMap
  currentMap['tag'] = 'CITA.ConferenceCitation.stateProvince'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00030'
  currentMap['name'] = 'stateProvince'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute ConferenceCitation.status
  contentMap['status'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00012')

  # Attribute ConferenceCitation.title
  contentMap['title'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00011')

  # Attribute ConferenceCitation.year
  contentMap['year'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00019')

  # Role ConferenceCitation.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role ConferenceCitation.authors
  contentMap['authors'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00002')

  # Role ConferenceCitation.editors
  contentMap['editors'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00004')
  # End of ConferenceCitation

  currentMap = abstractTypes.get('ConferenceCitation')
  aList = ['serial', 'year']
  currentMap['headerAttrs'] = aList
  aList = ['abstractNumber', 'casAbstractCode', 'city', 'conferenceSite', 'conferenceTitle', 'country', 'details', 'doi', 'endDate', 'firstPage', 'keywords', 'lastPage', 'medlineUiCode', 'pubMedId', 'startDate', 'stateProvince', 'status', 'title']
  currentMap['simpleAttrs'] = aList
  aList = ['editors', 'authors', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class BookCitation
  currentMap = {}
  abstractTypes['BookCitation'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00012'] = currentMap
  loadMaps['CITA.BookCitation'] = currentMap
  currentMap['tag'] = 'CITA.BookCitation'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00012'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'citations'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.Citation.BookCitation
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute BookCitation.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute BookCitation.bookSeries
  currentMap = {}
  contentMap['bookSeries'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00023'] = currentMap
  loadMaps['CITA.BookCitation.bookSeries'] = currentMap
  currentMap['tag'] = 'CITA.BookCitation.bookSeries'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00023'
  currentMap['name'] = 'bookSeries'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute BookCitation.bookTitle
  currentMap = {}
  contentMap['bookTitle'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00021'] = currentMap
  loadMaps['CITA.BookCitation.bookTitle'] = currentMap
  currentMap['tag'] = 'CITA.BookCitation.bookTitle'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00021'
  currentMap['name'] = 'bookTitle'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute BookCitation.casAbstractCode
  contentMap['casAbstractCode'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00014')

  # Attribute BookCitation.details
  contentMap['details'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00020')

  # Attribute BookCitation.doi
  contentMap['doi'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00013')

  # Attribute BookCitation.firstPage
  contentMap['firstPage'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00017')

  # Attribute BookCitation.isbn
  currentMap = {}
  contentMap['isbn'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00026'] = currentMap
  loadMaps['CITA.BookCitation.isbn'] = currentMap
  currentMap['tag'] = 'CITA.BookCitation.isbn'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00026'
  currentMap['name'] = 'isbn'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute BookCitation.keywords
  contentMap['keywords'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00010')

  # Attribute BookCitation.lastPage
  contentMap['lastPage'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00018')

  # Attribute BookCitation.medlineUiCode
  contentMap['medlineUiCode'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00015')

  # Attribute BookCitation.pubMedId
  contentMap['pubMedId'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00016')

  # Attribute BookCitation.publisher
  currentMap = {}
  contentMap['publisher'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00024'] = currentMap
  loadMaps['CITA.BookCitation.publisher'] = currentMap
  currentMap['tag'] = 'CITA.BookCitation.publisher'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00024'
  currentMap['name'] = 'publisher'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute BookCitation.publisherCity
  currentMap = {}
  contentMap['publisherCity'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00025'] = currentMap
  loadMaps['CITA.BookCitation.publisherCity'] = currentMap
  currentMap['tag'] = 'CITA.BookCitation.publisherCity'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00025'
  currentMap['name'] = 'publisherCity'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute BookCitation.serial
  contentMap['serial'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00009')

  # Attribute BookCitation.status
  contentMap['status'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00012')

  # Attribute BookCitation.title
  contentMap['title'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00011')

  # Attribute BookCitation.volume
  currentMap = {}
  contentMap['volume'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00022'] = currentMap
  loadMaps['CITA.BookCitation.volume'] = currentMap
  currentMap['tag'] = 'CITA.BookCitation.volume'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00022'
  currentMap['name'] = 'volume'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute BookCitation.year
  contentMap['year'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00019')

  # Role BookCitation.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role BookCitation.authors
  contentMap['authors'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00002')

  # Role BookCitation.editors
  contentMap['editors'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-18:23:13_00004')
  # End of BookCitation

  currentMap = abstractTypes.get('BookCitation')
  aList = ['serial', 'year']
  currentMap['headerAttrs'] = aList
  aList = ['bookSeries', 'bookTitle', 'casAbstractCode', 'details', 'doi', 'firstPage', 'isbn', 'keywords', 'lastPage', 'medlineUiCode', 'pubMedId', 'publisher', 'publisherCity', 'status', 'title', 'volume']
  currentMap['simpleAttrs'] = aList
  aList = ['editors', 'authors', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Out-of-package link to CitationStore
  currentMap = {}
  exolinks['CitationStore'] = currentMap
  loadMaps['CITA.exo-CitationStore'] = currentMap
  currentMap['tag'] = 'CITA.exo-CitationStore'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00017'
  currentMap['name'] = 'CitationStore'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.general.Citation.CitationStore
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))

  # Out-of-package link to JournalCitation
  currentMap = {}
  exolinks['JournalCitation'] = currentMap
  loadMaps['CITA.exo-JournalCitation'] = currentMap
  currentMap['tag'] = 'CITA.exo-JournalCitation'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00015'
  currentMap['name'] = 'JournalCitation'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.general.Citation.JournalCitation
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to ThesisCitation
  currentMap = {}
  exolinks['ThesisCitation'] = currentMap
  loadMaps['CITA.exo-ThesisCitation'] = currentMap
  currentMap['tag'] = 'CITA.exo-ThesisCitation'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00014'
  currentMap['name'] = 'ThesisCitation'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.general.Citation.ThesisCitation
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to ConferenceCitation
  currentMap = {}
  exolinks['ConferenceCitation'] = currentMap
  loadMaps['CITA.exo-ConferenceCitation'] = currentMap
  currentMap['tag'] = 'CITA.exo-ConferenceCitation'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00013'
  currentMap['name'] = 'ConferenceCitation'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.general.Citation.ConferenceCitation
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to BookCitation
  currentMap = {}
  exolinks['BookCitation'] = currentMap
  loadMaps['CITA.exo-BookCitation'] = currentMap
  currentMap['tag'] = 'CITA.exo-BookCitation'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:55_00012'
  currentMap['name'] = 'BookCitation'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.general.Citation.BookCitation
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
