"""
#######################################################################

CCPN Data Model version 2.1.2

Autogenerated by PyXmlMapWrite revision 1.29 on Mon Mar  2 17:24:09 2015
  from data model element ccp.general.DataLocation revision ?

#######################################################################
======================COPYRIGHT/LICENSE START==========================

DataLocation.py: python XML-I/O-mapping for CCPN data model, MetaPackage ccp.general.DataLocation

Copyright (C) 2007  (CCPN Project)

=======================================================================

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.
 
A copy of this license can be found in ../../../../license/LGPL.license
 
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
 
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


======================COPYRIGHT/LICENSE END============================

for further information, please contact :

- CCPN website (http://www.ccpn.ac.uk/)

- email: ccpn@bioc.cam.ac.uk

=======================================================================

If you are using this software for academic purposes, we suggest
quoting the following references:

===========================REFERENCE START=============================
Rasmus H. Fogh, Wayne Boucher, Wim F. Vranken, Anne
Pajon, Tim J. Stevens, T.N. Bhat, John Westbrook, John M.C. Ionides and
Ernest D. Laue (2005). A framework for scientific data modeling and automated
software development. Bioinformatics 21, 1678-1684.


This file was generated with the Memops software generation framework,
and contains original contributions embedded in the framework

===========================REFERENCE END===============================
"""
from memops.general.Constants import baseDataTypeModule as basicDataTypes
# 
#  Current package api
import ccp.api.general.DataLocation

def makeMapping(globalMap):
  """
  generates XML I/O mapping for package DLOC, adding it to globalMap
  """
  
  from memops.xml.Implementation import bool2str, str2bool

  # Set up top level dictionaries
  loadMaps = globalMap.get('loadMaps')
  mapsByGuid = globalMap.get('mapsByGuid')

  abstractTypes = globalMap.get('DLOC').get('abstractTypes')
  exolinks = globalMap.get('DLOC').get('exolinks')

  # DataType ComplexStorage
  currentMap = {}
  abstractTypes['ComplexStorage'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00003'] = currentMap
  loadMaps['DLOC.ComplexStorage'] = currentMap
  currentMap['tag'] = 'DLOC.ComplexStorage'
  currentMap['type'] = 'simple'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00003'
  currentMap['toStr'] = 'text'
  currentMap['cnvrt'] = 'text'

  # DataType ComponentStatus
  currentMap = {}
  abstractTypes['ComponentStatus'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-19-17:41:34_00002'] = currentMap
  loadMaps['DLOC.ComponentStatus'] = currentMap
  currentMap['tag'] = 'DLOC.ComponentStatus'
  currentMap['type'] = 'simple'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-19-17:41:34_00002'
  currentMap['toStr'] = 'text'
  currentMap['cnvrt'] = 'text'

  # DataType DataEncoding
  currentMap = {}
  abstractTypes['DataEncoding'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00006'] = currentMap
  loadMaps['DLOC.DataEncoding'] = currentMap
  currentMap['tag'] = 'DLOC.DataEncoding'
  currentMap['type'] = 'simple'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00006'
  currentMap['toStr'] = 'text'
  currentMap['cnvrt'] = 'text'

  # DataType MatrixFileType
  currentMap = {}
  abstractTypes['MatrixFileType'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-11-15:00:22_00001'] = currentMap
  loadMaps['DLOC.MatrixFileType'] = currentMap
  currentMap['tag'] = 'DLOC.MatrixFileType'
  currentMap['type'] = 'simple'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-11-15:00:22_00001'
  currentMap['toStr'] = 'text'
  currentMap['cnvrt'] = 'text'

  # DataType NumberType
  currentMap = {}
  abstractTypes['NumberType'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2006-08-16-14:22:48_00034'] = currentMap
  loadMaps['DLOC.NumberType'] = currentMap
  currentMap['tag'] = 'DLOC.NumberType'
  currentMap['type'] = 'simple'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2006-08-16-14:22:48_00034'
  currentMap['toStr'] = 'text'
  currentMap['cnvrt'] = 'text'

  # Class AbstractDataStore
  currentMap = {}
  abstractTypes['AbstractDataStore'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-03-19:08:10_00005'] = currentMap
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-03-19:08:10_00005'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'dataStores'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.DataLocation.AbstractDataStore
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute AbstractDataStore.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute AbstractDataStore.details
  currentMap = {}
  contentMap['details'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-11-07-17:54:39_00001'] = currentMap
  loadMaps['DLOC.AbstractDataStore.details'] = currentMap
  currentMap['tag'] = 'DLOC.AbstractDataStore.details'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-11-07-17:54:39_00001'
  currentMap['name'] = 'details'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute AbstractDataStore.path
  currentMap = {}
  contentMap['path'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-11-09-10:08:29_00001'] = currentMap
  loadMaps['DLOC.AbstractDataStore.path'] = currentMap
  currentMap['tag'] = 'DLOC.AbstractDataStore.path'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-11-09-10:08:29_00001'
  currentMap['name'] = 'path'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00003')

  # Attribute AbstractDataStore.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00004'] = currentMap
  loadMaps['DLOC.AbstractDataStore.serial'] = currentMap
  currentMap['tag'] = 'DLOC.AbstractDataStore.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00004'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Role AbstractDataStore.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role AbstractDataStore.dataUrl
  currentMap = {}
  contentMap['dataUrl'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-11-09-10:09:29_00001'] = currentMap
  loadMaps['DLOC.AbstractDataStore.dataUrl'] = currentMap
  currentMap['tag'] = 'DLOC.AbstractDataStore.dataUrl'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-11-09-10:09:29_00001'
  currentMap['name'] = 'dataUrl'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['copyOverride'] = True
  # End of AbstractDataStore

  currentMap = abstractTypes.get('AbstractDataStore')
  aList = ['serial']
  currentMap['headerAttrs'] = aList
  aList = ['details', 'path']
  currentMap['simpleAttrs'] = aList
  aList = ['dataUrl']
  currentMap['optLinks'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class Component
  currentMap = {}
  abstractTypes['Component'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-19-17:41:34_00001'] = currentMap
  loadMaps['DLOC.Component'] = currentMap
  currentMap['tag'] = 'DLOC.Component'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-19-17:41:34_00001'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'components'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.DataLocation.Component
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute Component.amplitude
  currentMap = {}
  contentMap['amplitude'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00002'] = currentMap
  loadMaps['DLOC.Component.amplitude'] = currentMap
  currentMap['tag'] = 'DLOC.Component.amplitude'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00002'
  currentMap['name'] = 'amplitude'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00009')

  # Attribute Component.annotation
  currentMap = {}
  contentMap['annotation'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00005'] = currentMap
  loadMaps['DLOC.Component.annotation'] = currentMap
  currentMap['tag'] = 'DLOC.Component.annotation'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00005'
  currentMap['name'] = 'annotation'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute Component.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute Component.regionId
  currentMap = {}
  contentMap['regionId'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00003'] = currentMap
  loadMaps['DLOC.Component.regionId'] = currentMap
  currentMap['tag'] = 'DLOC.Component.regionId'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00003'
  currentMap['name'] = 'regionId'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00011')

  # Attribute Component.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00001'] = currentMap
  loadMaps['DLOC.Component.serial'] = currentMap
  currentMap['tag'] = 'DLOC.Component.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00001'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute Component.status
  currentMap = {}
  contentMap['status'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00004'] = currentMap
  loadMaps['DLOC.Component.status'] = currentMap
  currentMap['tag'] = 'DLOC.Component.status'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00004'
  currentMap['name'] = 'status'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 'raw'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2009-06-19-17:41:34_00002')

  # Role Component.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')
  # End of Component

  currentMap = abstractTypes.get('Component')
  aList = ['amplitude', 'regionId', 'serial', 'status']
  currentMap['headerAttrs'] = aList
  aList = ['annotation']
  currentMap['simpleAttrs'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class ComponentShape
  currentMap = {}
  abstractTypes['ComponentShape'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00007'] = currentMap
  loadMaps['DLOC.ComponentShape'] = currentMap
  currentMap['tag'] = 'DLOC.ComponentShape'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00007'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'componentShapes'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.DataLocation.ComponentShape
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute ComponentShape.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute ComponentShape.dims
  currentMap = {}
  contentMap['dims'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00006'] = currentMap
  loadMaps['DLOC.ComponentShape.dims'] = currentMap
  currentMap['tag'] = 'DLOC.ComponentShape.dims'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00006'
  currentMap['name'] = 'dims'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute ComponentShape.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00005'] = currentMap
  loadMaps['DLOC.ComponentShape.serial'] = currentMap
  currentMap['tag'] = 'DLOC.ComponentShape.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00005'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Role ComponentShape.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')
  # End of ComponentShape

  currentMap = abstractTypes.get('ComponentShape')
  aList = ['serial']
  currentMap['headerAttrs'] = aList
  aList = ['dims']
  currentMap['simpleAttrs'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class DataLocationStore
  currentMap = {}
  abstractTypes['DataLocationStore'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-03-19:08:10_00002'] = currentMap
  loadMaps['DLOC.DataLocationStore'] = currentMap
  currentMap['tag'] = 'DLOC.DataLocationStore'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-03-19:08:10_00002'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'dataLocationStores'
  currentMap['isTop'] = True
  currentMap['objkey'] = 'name'
  currentMap['class'] = ccp.api.general.DataLocation.DataLocationStore
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute DataLocationStore.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute DataLocationStore.createdBy
  contentMap['createdBy'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:00:59_00002__www.ccpn.ac.uk_Fogh_2007-10-03-14:53:27_00001__www.ccpn.ac.uk_Fogh_2006-09-14-16:28:57_00002')

  # Attribute DataLocationStore.guid
  contentMap['guid'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:26_00002')

  # Attribute DataLocationStore.isModifiable
  contentMap['isModifiable'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-17-14:16:26_00010__www.ccpn.ac.uk_Fogh_2007-10-03-14:53:27_00001__www.ccpn.ac.uk_Fogh_2006-09-14-16:28:57_00002')

  # Attribute DataLocationStore.lastUnlockedBy
  contentMap['lastUnlockedBy'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:00:59_00003__www.ccpn.ac.uk_Fogh_2007-10-03-14:53:27_00001__www.ccpn.ac.uk_Fogh_2006-09-14-16:28:57_00002')

  # Attribute DataLocationStore.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00010'] = currentMap
  loadMaps['DLOC.DataLocationStore.name'] = currentMap
  currentMap['tag'] = 'DLOC.DataLocationStore.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00010'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Role DataLocationStore.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role DataLocationStore.dataStores
  currentMap = {}
  contentMap['dataStores'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00009'] = currentMap
  loadMaps['DLOC.DataLocationStore.dataStores'] = currentMap
  currentMap['tag'] = 'DLOC.DataLocationStore.dataStores'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00009'
  currentMap['name'] = 'dataStores'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('DLOC').get('abstractTypes')

  # Role DataLocationStore.dataUrls
  currentMap = {}
  contentMap['dataUrls'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00007'] = currentMap
  loadMaps['DLOC.DataLocationStore.dataUrls'] = currentMap
  currentMap['tag'] = 'DLOC.DataLocationStore.dataUrls'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00007'
  currentMap['name'] = 'dataUrls'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('DLOC').get('abstractTypes')
  # End of DataLocationStore

  currentMap = abstractTypes.get('DataLocationStore')
  aList = ['createdBy', 'guid', 'isModifiable', 'lastUnlockedBy']
  currentMap['headerAttrs'] = aList
  aList = ['name']
  currentMap['simpleAttrs'] = aList
  aList = ['dataUrls', 'dataStores', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['dataStores', 'dataUrls']
  currentMap['children'] = aList

  # Class DataUrl
  currentMap = {}
  abstractTypes['DataUrl'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-03-19:08:10_00003'] = currentMap
  loadMaps['DLOC.DataUrl'] = currentMap
  currentMap['tag'] = 'DLOC.DataUrl'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-03-19:08:10_00003'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'dataUrls'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.DataLocation.DataUrl
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute DataUrl.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute DataUrl.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00014'] = currentMap
  loadMaps['DLOC.DataUrl.name'] = currentMap
  currentMap['tag'] = 'DLOC.DataUrl.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00014'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute DataUrl.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00013'] = currentMap
  loadMaps['DLOC.DataUrl.serial'] = currentMap
  currentMap['tag'] = 'DLOC.DataUrl.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00013'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute DataUrl.url
  currentMap = {}
  contentMap['url'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00015'] = currentMap
  loadMaps['DLOC.DataUrl.url'] = currentMap
  currentMap['tag'] = 'DLOC.DataUrl.url'
  currentMap['type'] = 'dobj'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00015'
  currentMap['name'] = 'url'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('IMPL').get('abstractTypes')

  # Role DataUrl.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role DataUrl.dataStores
  currentMap = {}
  contentMap['dataStores'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-11-09-10:09:29_00002'] = currentMap
  loadMaps['DLOC.DataUrl.dataStores'] = currentMap
  currentMap['tag'] = 'DLOC.DataUrl.dataStores'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-11-09-10:09:29_00002'
  currentMap['name'] = 'dataStores'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['copyOverride'] = False
  # End of DataUrl

  currentMap = abstractTypes.get('DataUrl')
  aList = ['serial']
  currentMap['headerAttrs'] = aList
  aList = ['name', 'dataStores']
  currentMap['simpleAttrs'] = aList
  aList = ['access', 'url', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class NumericMatrix
  currentMap = {}
  abstractTypes['NumericMatrix'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00002'] = currentMap
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00002'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'dataStores'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.DataLocation.NumericMatrix
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute NumericMatrix.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute NumericMatrix.complexStoredBy
  currentMap = {}
  contentMap['complexStoredBy'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00014'] = currentMap
  loadMaps['DLOC.NumericMatrix.complexStoredBy'] = currentMap
  currentMap['tag'] = 'DLOC.NumericMatrix.complexStoredBy'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00014'
  currentMap['name'] = 'complexStoredBy'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 'dimension'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00003')

  # Attribute NumericMatrix.details
  contentMap['details'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-11-07-17:54:39_00001')

  # Attribute NumericMatrix.fileType
  currentMap = {}
  contentMap['fileType'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-11-15:00:26_00001'] = currentMap
  loadMaps['DLOC.NumericMatrix.fileType'] = currentMap
  currentMap['tag'] = 'DLOC.NumericMatrix.fileType'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-11-15:00:26_00001'
  currentMap['name'] = 'fileType'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2009-06-11-15:00:22_00001')

  # Attribute NumericMatrix.isBigEndian
  currentMap = {}
  contentMap['isBigEndian'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00002'] = currentMap
  loadMaps['DLOC.NumericMatrix.isBigEndian'] = currentMap
  currentMap['tag'] = 'DLOC.NumericMatrix.isBigEndian'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00002'
  currentMap['name'] = 'isBigEndian'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute NumericMatrix.isComplex
  currentMap = {}
  contentMap['isComplex'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00012'] = currentMap
  loadMaps['DLOC.NumericMatrix.isComplex'] = currentMap
  currentMap['tag'] = 'DLOC.NumericMatrix.isComplex'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00012'
  currentMap['name'] = 'isComplex'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute NumericMatrix.numPoints
  currentMap = {}
  contentMap['numPoints'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00008'] = currentMap
  loadMaps['DLOC.NumericMatrix.numPoints'] = currentMap
  currentMap['tag'] = 'DLOC.NumericMatrix.numPoints'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00008'
  currentMap['name'] = 'numPoints'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute NumericMatrix.numRecords
  currentMap = {}
  contentMap['numRecords'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00010'] = currentMap
  loadMaps['DLOC.NumericMatrix.numRecords'] = currentMap
  currentMap['tag'] = 'DLOC.NumericMatrix.numRecords'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00010'
  currentMap['name'] = 'numRecords'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['proc'] = 'direct'
  currentMap['default'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute NumericMatrix.numberType
  currentMap = {}
  contentMap['numberType'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00011'] = currentMap
  loadMaps['DLOC.NumericMatrix.numberType'] = currentMap
  currentMap['tag'] = 'DLOC.NumericMatrix.numberType'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00011'
  currentMap['name'] = 'numberType'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 'float'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:48_00034')

  # Attribute NumericMatrix.path
  contentMap['path'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-11-09-10:08:29_00001')

  # Attribute NumericMatrix.scaleFactor
  currentMap = {}
  contentMap['scaleFactor'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2008-02-12-16:37:31_00001'] = currentMap
  loadMaps['DLOC.NumericMatrix.scaleFactor'] = currentMap
  currentMap['tag'] = 'DLOC.NumericMatrix.scaleFactor'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2008-02-12-16:37:31_00001'
  currentMap['name'] = 'scaleFactor'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00007')

  # Attribute NumericMatrix.serial
  contentMap['serial'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00004')

  # Role NumericMatrix.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role NumericMatrix.dataUrl
  contentMap['dataUrl'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-11-09-10:09:29_00001')
  # End of NumericMatrix

  currentMap = abstractTypes.get('NumericMatrix')
  aList = ['complexStoredBy', 'fileType', 'isBigEndian', 'numRecords', 'numberType', 'scaleFactor', 'serial']
  currentMap['headerAttrs'] = aList
  aList = ['details', 'isComplex', 'numPoints', 'path']
  currentMap['simpleAttrs'] = aList
  aList = ['dataUrl']
  currentMap['optLinks'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class MimeTypeDataStore
  currentMap = {}
  abstractTypes['MimeTypeDataStore'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00001'] = currentMap
  loadMaps['DLOC.MimeTypeDataStore'] = currentMap
  currentMap['tag'] = 'DLOC.MimeTypeDataStore'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00001'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'dataStores'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.DataLocation.MimeTypeDataStore
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute MimeTypeDataStore.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute MimeTypeDataStore.details
  contentMap['details'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-11-07-17:54:39_00001')

  # Attribute MimeTypeDataStore.mimeType
  currentMap = {}
  contentMap['mimeType'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00007'] = currentMap
  loadMaps['DLOC.MimeTypeDataStore.mimeType'] = currentMap
  currentMap['tag'] = 'DLOC.MimeTypeDataStore.mimeType'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00007'
  currentMap['name'] = 'mimeType'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute MimeTypeDataStore.path
  contentMap['path'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-11-09-10:08:29_00001')

  # Attribute MimeTypeDataStore.serial
  contentMap['serial'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00004')

  # Role MimeTypeDataStore.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role MimeTypeDataStore.dataUrl
  contentMap['dataUrl'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-11-09-10:09:29_00001')
  # End of MimeTypeDataStore

  currentMap = abstractTypes.get('MimeTypeDataStore')
  aList = ['serial']
  currentMap['headerAttrs'] = aList
  aList = ['details', 'mimeType', 'path']
  currentMap['simpleAttrs'] = aList
  aList = ['dataUrl']
  currentMap['optLinks'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class BlockedBinaryMatrix
  currentMap = {}
  abstractTypes['BlockedBinaryMatrix'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00004'] = currentMap
  loadMaps['DLOC.BlockedBinaryMatrix'] = currentMap
  currentMap['tag'] = 'DLOC.BlockedBinaryMatrix'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00004'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'dataStores'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.DataLocation.BlockedBinaryMatrix
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute BlockedBinaryMatrix.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute BlockedBinaryMatrix.blockHeaderSize
  currentMap = {}
  contentMap['blockHeaderSize'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-04-23-15:13:31_00001'] = currentMap
  loadMaps['DLOC.BlockedBinaryMatrix.blockHeaderSize'] = currentMap
  currentMap['tag'] = 'DLOC.BlockedBinaryMatrix.blockHeaderSize'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-04-23-15:13:31_00001'
  currentMap['name'] = 'blockHeaderSize'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00011')

  # Attribute BlockedBinaryMatrix.blockSizes
  currentMap = {}
  contentMap['blockSizes'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:45:25_00002'] = currentMap
  loadMaps['DLOC.BlockedBinaryMatrix.blockSizes'] = currentMap
  currentMap['tag'] = 'DLOC.BlockedBinaryMatrix.blockSizes'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:45:25_00002'
  currentMap['name'] = 'blockSizes'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute BlockedBinaryMatrix.complexStoredBy
  contentMap['complexStoredBy'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00014')

  # Attribute BlockedBinaryMatrix.details
  contentMap['details'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-11-07-17:54:39_00001')

  # Attribute BlockedBinaryMatrix.fileType
  contentMap['fileType'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2009-06-11-15:00:26_00001')

  # Attribute BlockedBinaryMatrix.hasBlockPadding
  currentMap = {}
  contentMap['hasBlockPadding'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00003'] = currentMap
  loadMaps['DLOC.BlockedBinaryMatrix.hasBlockPadding'] = currentMap
  currentMap['tag'] = 'DLOC.BlockedBinaryMatrix.hasBlockPadding'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00003'
  currentMap['name'] = 'hasBlockPadding'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute BlockedBinaryMatrix.headerSize
  currentMap = {}
  contentMap['headerSize'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00004'] = currentMap
  loadMaps['DLOC.BlockedBinaryMatrix.headerSize'] = currentMap
  currentMap['tag'] = 'DLOC.BlockedBinaryMatrix.headerSize'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00004'
  currentMap['name'] = 'headerSize'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['proc'] = 'direct'
  currentMap['default'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute BlockedBinaryMatrix.isBigEndian
  contentMap['isBigEndian'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00002')

  # Attribute BlockedBinaryMatrix.isComplex
  contentMap['isComplex'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00012')

  # Attribute BlockedBinaryMatrix.nByte
  currentMap = {}
  contentMap['nByte'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:45:25_00001'] = currentMap
  loadMaps['DLOC.BlockedBinaryMatrix.nByte'] = currentMap
  currentMap['tag'] = 'DLOC.BlockedBinaryMatrix.nByte'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:45:25_00001'
  currentMap['name'] = 'nByte'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['proc'] = 'direct'
  currentMap['default'] = 4
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute BlockedBinaryMatrix.numPoints
  contentMap['numPoints'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00008')

  # Attribute BlockedBinaryMatrix.numRecords
  contentMap['numRecords'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00010')

  # Attribute BlockedBinaryMatrix.numberType
  contentMap['numberType'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00011')

  # Attribute BlockedBinaryMatrix.path
  contentMap['path'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-11-09-10:08:29_00001')

  # Attribute BlockedBinaryMatrix.scaleFactor
  contentMap['scaleFactor'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-02-12-16:37:31_00001')

  # Attribute BlockedBinaryMatrix.serial
  contentMap['serial'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00004')

  # Role BlockedBinaryMatrix.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role BlockedBinaryMatrix.dataUrl
  contentMap['dataUrl'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-11-09-10:09:29_00001')
  # End of BlockedBinaryMatrix

  currentMap = abstractTypes.get('BlockedBinaryMatrix')
  aList = ['blockHeaderSize', 'complexStoredBy', 'fileType', 'hasBlockPadding', 'headerSize', 'isBigEndian', 'nByte', 'numRecords', 'numberType', 'scaleFactor', 'serial']
  currentMap['headerAttrs'] = aList
  aList = ['blockSizes', 'details', 'isComplex', 'numPoints', 'path']
  currentMap['simpleAttrs'] = aList
  aList = ['dataUrl']
  currentMap['optLinks'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class ShapeMatrix
  currentMap = {}
  abstractTypes['ShapeMatrix'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00005'] = currentMap
  loadMaps['DLOC.ShapeMatrix'] = currentMap
  currentMap['tag'] = 'DLOC.ShapeMatrix'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00005'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'dataStores'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.general.DataLocation.ShapeMatrix
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute ShapeMatrix.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute ShapeMatrix.complexStoredBy
  contentMap['complexStoredBy'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00014')

  # Attribute ShapeMatrix.dataEncoding
  currentMap = {}
  contentMap['dataEncoding'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00019'] = currentMap
  loadMaps['DLOC.ShapeMatrix.dataEncoding'] = currentMap
  currentMap['tag'] = 'DLOC.ShapeMatrix.dataEncoding'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00019'
  currentMap['name'] = 'dataEncoding'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 'ascii'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00006')

  # Attribute ShapeMatrix.details
  contentMap['details'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-11-07-17:54:39_00001')

  # Attribute ShapeMatrix.fileType
  contentMap['fileType'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2009-06-11-15:00:26_00001')

  # Attribute ShapeMatrix.headerSize
  currentMap = {}
  contentMap['headerSize'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00020'] = currentMap
  loadMaps['DLOC.ShapeMatrix.headerSize'] = currentMap
  currentMap['tag'] = 'DLOC.ShapeMatrix.headerSize'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00020'
  currentMap['name'] = 'headerSize'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['proc'] = 'direct'
  currentMap['default'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute ShapeMatrix.isBigEndian
  contentMap['isBigEndian'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00002')

  # Attribute ShapeMatrix.isComplex
  contentMap['isComplex'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00012')

  # Attribute ShapeMatrix.isReconstructable
  currentMap = {}
  contentMap['isReconstructable'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00009'] = currentMap
  loadMaps['DLOC.ShapeMatrix.isReconstructable'] = currentMap
  currentMap['tag'] = 'DLOC.ShapeMatrix.isReconstructable'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00009'
  currentMap['name'] = 'isReconstructable'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute ShapeMatrix.isResolved
  currentMap = {}
  contentMap['isResolved'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00010'] = currentMap
  loadMaps['DLOC.ShapeMatrix.isResolved'] = currentMap
  currentMap['tag'] = 'DLOC.ShapeMatrix.isResolved'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00010'
  currentMap['name'] = 'isResolved'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute ShapeMatrix.numPoints
  contentMap['numPoints'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00008')

  # Attribute ShapeMatrix.numRecords
  contentMap['numRecords'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00010')

  # Attribute ShapeMatrix.numShapes
  currentMap = {}
  contentMap['numShapes'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00008'] = currentMap
  loadMaps['DLOC.ShapeMatrix.numShapes'] = currentMap
  currentMap['tag'] = 'DLOC.ShapeMatrix.numShapes'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00008'
  currentMap['name'] = 'numShapes'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00001')

  # Attribute ShapeMatrix.numberType
  contentMap['numberType'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00011')

  # Attribute ShapeMatrix.path
  contentMap['path'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-11-09-10:08:29_00001')

  # Attribute ShapeMatrix.scaleFactor
  contentMap['scaleFactor'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-02-12-16:37:31_00001')

  # Attribute ShapeMatrix.serial
  contentMap['serial'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-04-03-19:10:36_00004')

  # Role ShapeMatrix.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role ShapeMatrix.componentShapes
  currentMap = {}
  contentMap['componentShapes'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00018'] = currentMap
  loadMaps['DLOC.ShapeMatrix.componentShapes'] = currentMap
  currentMap['tag'] = 'DLOC.ShapeMatrix.componentShapes'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:46:36_00018'
  currentMap['name'] = 'componentShapes'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('DLOC').get('abstractTypes')

  # Role ShapeMatrix.components
  currentMap = {}
  contentMap['components'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00007'] = currentMap
  loadMaps['DLOC.ShapeMatrix.components'] = currentMap
  currentMap['tag'] = 'DLOC.ShapeMatrix.components'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-19-17:42:00_00007'
  currentMap['name'] = 'components'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('DLOC').get('abstractTypes')

  # Role ShapeMatrix.dataUrl
  contentMap['dataUrl'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2007-11-09-10:09:29_00001')
  # End of ShapeMatrix

  currentMap = abstractTypes.get('ShapeMatrix')
  aList = ['complexStoredBy', 'dataEncoding', 'fileType', 'headerSize', 'isBigEndian', 'isReconstructable', 'isResolved', 'numRecords', 'numShapes', 'numberType', 'scaleFactor', 'serial']
  currentMap['headerAttrs'] = aList
  aList = ['details', 'isComplex', 'numPoints', 'path']
  currentMap['simpleAttrs'] = aList
  aList = ['dataUrl']
  currentMap['optLinks'] = aList
  aList = ['components', 'componentShapes', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['componentShapes', 'components']
  currentMap['children'] = aList

  # Out-of-package link to Component
  currentMap = {}
  exolinks['Component'] = currentMap
  loadMaps['DLOC.exo-Component'] = currentMap
  currentMap['tag'] = 'DLOC.exo-Component'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-06-19-17:41:34_00001'
  currentMap['name'] = 'Component'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.general.DataLocation.Component
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to ComponentShape
  currentMap = {}
  exolinks['ComponentShape'] = currentMap
  loadMaps['DLOC.exo-ComponentShape'] = currentMap
  currentMap['tag'] = 'DLOC.exo-ComponentShape'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00007'
  currentMap['name'] = 'ComponentShape'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.general.DataLocation.ComponentShape
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to DataLocationStore
  currentMap = {}
  exolinks['DataLocationStore'] = currentMap
  loadMaps['DLOC.exo-DataLocationStore'] = currentMap
  currentMap['tag'] = 'DLOC.exo-DataLocationStore'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-03-19:08:10_00002'
  currentMap['name'] = 'DataLocationStore'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.general.DataLocation.DataLocationStore
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))

  # Out-of-package link to DataUrl
  currentMap = {}
  exolinks['DataUrl'] = currentMap
  loadMaps['DLOC.exo-DataUrl'] = currentMap
  currentMap['tag'] = 'DLOC.exo-DataUrl'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-03-19:08:10_00003'
  currentMap['name'] = 'DataUrl'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.general.DataLocation.DataUrl
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to MimeTypeDataStore
  currentMap = {}
  exolinks['MimeTypeDataStore'] = currentMap
  loadMaps['DLOC.exo-MimeTypeDataStore'] = currentMap
  currentMap['tag'] = 'DLOC.exo-MimeTypeDataStore'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00001'
  currentMap['name'] = 'MimeTypeDataStore'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.general.DataLocation.MimeTypeDataStore
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to BlockedBinaryMatrix
  currentMap = {}
  exolinks['BlockedBinaryMatrix'] = currentMap
  loadMaps['DLOC.exo-BlockedBinaryMatrix'] = currentMap
  currentMap['tag'] = 'DLOC.exo-BlockedBinaryMatrix'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00004'
  currentMap['name'] = 'BlockedBinaryMatrix'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.general.DataLocation.BlockedBinaryMatrix
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to ShapeMatrix
  currentMap = {}
  exolinks['ShapeMatrix'] = currentMap
  loadMaps['DLOC.exo-ShapeMatrix'] = currentMap
  currentMap['tag'] = 'DLOC.exo-ShapeMatrix'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2007-04-04-17:43:15_00005'
  currentMap['name'] = 'ShapeMatrix'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.general.DataLocation.ShapeMatrix
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
