"""
#######################################################################

CCPN Data Model version 2.1.2

Autogenerated by PyXmlMapWrite revision 1.29 on Mon Mar  2 17:24:14 2015
  from data model element ccp.nmr.NmrScreen revision ?

#######################################################################
======================COPYRIGHT/LICENSE START==========================

NmrScreen.py: python XML-I/O-mapping for CCPN data model, MetaPackage ccp.nmr.NmrScreen

Copyright (C) 2007 Rasmus Fogh (CCPN Project)

=======================================================================

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.
 
A copy of this license can be found in ../../../../license/LGPL.license
 
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
 
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


======================COPYRIGHT/LICENSE END============================

for further information, please contact :

- CCPN website (http://www.ccpn.ac.uk/)

- email: ccpn@bioc.cam.ac.uk

=======================================================================

If you are using this software for academic purposes, we suggest
quoting the following references:

===========================REFERENCE START=============================
Wim F. Vranken, Wayne Boucher, Tim J. Stevens, Rasmus
H. Fogh, Anne Pajon, Miguel Llinas, Eldon L. Ulrich, John L. Markley, John
Ionides and Ernest D. Laue (2005). The CCPN Data Model for NMR Spectroscopy:
Development of a Software Pipeline. Proteins 59, 687 - 696.

Rasmus H. Fogh, Wayne Boucher, Wim F. Vranken, Anne
Pajon, Tim J. Stevens, T.N. Bhat, John Westbrook, John M.C. Ionides and
Ernest D. Laue (2005). A framework for scientific data modeling and automated
software development. Bioinformatics 21, 1678-1684.


This file was generated with the Memops software generation framework,
and contains original contributions embedded in the framework

===========================REFERENCE END===============================
"""
from memops.general.Constants import baseDataTypeModule as basicDataTypes
# 
#  Current package api
import ccp.api.nmr.NmrScreen

def makeMapping(globalMap):
  """
  generates XML I/O mapping for package NMRS, adding it to globalMap
  """
  
  from memops.xml.Implementation import bool2str, str2bool

  # Set up top level dictionaries
  loadMaps = globalMap.get('loadMaps')
  mapsByGuid = globalMap.get('mapsByGuid')

  abstractTypes = globalMap.get('NMRS').get('abstractTypes')
  exolinks = globalMap.get('NMRS').get('exolinks')

  # DataType ComponentType
  currentMap = {}
  abstractTypes['ComponentType'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-03-28-17:18:50_00001'] = currentMap
  loadMaps['NMRS.ComponentType'] = currentMap
  currentMap['tag'] = 'NMRS.ComponentType'
  currentMap['type'] = 'simple'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-03-28-17:18:50_00001'
  currentMap['toStr'] = 'text'
  currentMap['cnvrt'] = 'text'

  # DataType ExpCode
  currentMap = {}
  abstractTypes['ExpCode'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:06_00001'] = currentMap
  loadMaps['NMRS.ExpCode'] = currentMap
  currentMap['tag'] = 'NMRS.ExpCode'
  currentMap['type'] = 'simple'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:06_00001'
  currentMap['toStr'] = 'text'
  currentMap['cnvrt'] = 'text'

  # Class ExperimentHit
  currentMap = {}
  abstractTypes['ExperimentHit'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00013'] = currentMap
  loadMaps['NMRS.ExperimentHit'] = currentMap
  currentMap['tag'] = 'NMRS.ExperimentHit'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00013'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'experimentHits'
  currentMap['objkey'] = 'trialExperiment'
  currentMap['class'] = ccp.api.nmr.NmrScreen.ExperimentHit
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute ExperimentHit.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute ExperimentHit.figOfMerit
  currentMap = {}
  contentMap['figOfMerit'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00010'] = currentMap
  loadMaps['NMRS.ExperimentHit.figOfMerit'] = currentMap
  currentMap['tag'] = 'NMRS.ExperimentHit.figOfMerit'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00010'
  currentMap['name'] = 'figOfMerit'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00058')

  # Attribute ExperimentHit.meritCode
  currentMap = {}
  contentMap['meritCode'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00011'] = currentMap
  loadMaps['NMRS.ExperimentHit.meritCode'] = currentMap
  currentMap['tag'] = 'NMRS.ExperimentHit.meritCode'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00011'
  currentMap['name'] = 'meritCode'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037')

  # Attribute ExperimentHit.normalisedChange
  currentMap = {}
  contentMap['normalisedChange'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-04-18-15:31:23_00001'] = currentMap
  loadMaps['NMRS.ExperimentHit.normalisedChange'] = currentMap
  currentMap['tag'] = 'NMRS.ExperimentHit.normalisedChange'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-04-18-15:31:23_00001'
  currentMap['name'] = 'normalisedChange'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00031')

  # Role ExperimentHit.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role ExperimentHit.trialExperiment
  currentMap = {}
  contentMap['trialExperiment'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00009'] = currentMap
  loadMaps['NMRS.ExperimentHit.trialExperiment'] = currentMap
  currentMap['tag'] = 'NMRS.ExperimentHit.trialExperiment'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00009'
  currentMap['name'] = 'trialExperiment'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['copyOverride'] = True
  # End of ExperimentHit

  currentMap = abstractTypes.get('ExperimentHit')
  aList = ['figOfMerit', 'meritCode', 'normalisedChange']
  currentMap['headerAttrs'] = aList
  aList = ['trialExperiment']
  currentMap['optLinks'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class ExperimentWeight
  currentMap = {}
  abstractTypes['ExperimentWeight'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-06-13:03:44_00001'] = currentMap
  loadMaps['NMRS.ExperimentWeight'] = currentMap
  currentMap['tag'] = 'NMRS.ExperimentWeight'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-06-13:03:44_00001'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'experimentWeights'
  currentMap['objkey'] = 'expCode'
  currentMap['class'] = ccp.api.nmr.NmrScreen.ExperimentWeight
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute ExperimentWeight.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute ExperimentWeight.changeIsPositive
  currentMap = {}
  contentMap['changeIsPositive'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-09-10:23:18_00001'] = currentMap
  loadMaps['NMRS.ExperimentWeight.changeIsPositive'] = currentMap
  currentMap['tag'] = 'NMRS.ExperimentWeight.changeIsPositive'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-09-10:23:18_00001'
  currentMap['name'] = 'changeIsPositive'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute ExperimentWeight.expCode
  currentMap = {}
  contentMap['expCode'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00001'] = currentMap
  loadMaps['NMRS.ExperimentWeight.expCode'] = currentMap
  currentMap['tag'] = 'NMRS.ExperimentWeight.expCode'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00001'
  currentMap['name'] = 'expCode'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2012-05-21-18:09:06_00001')

  # Attribute ExperimentWeight.intensityScale
  currentMap = {}
  contentMap['intensityScale'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00003'] = currentMap
  loadMaps['NMRS.ExperimentWeight.intensityScale'] = currentMap
  currentMap['tag'] = 'NMRS.ExperimentWeight.intensityScale'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00003'
  currentMap['name'] = 'intensityScale'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00031')

  # Attribute ExperimentWeight.meritThreshold
  currentMap = {}
  contentMap['meritThreshold'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00002'] = currentMap
  loadMaps['NMRS.ExperimentWeight.meritThreshold'] = currentMap
  currentMap['tag'] = 'NMRS.ExperimentWeight.meritThreshold'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00002'
  currentMap['name'] = 'meritThreshold'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00007')

  # Attribute ExperimentWeight.weight
  currentMap = {}
  contentMap['weight'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00004'] = currentMap
  loadMaps['NMRS.ExperimentWeight.weight'] = currentMap
  currentMap['tag'] = 'NMRS.ExperimentWeight.weight'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00004'
  currentMap['name'] = 'weight'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00009')

  # Role ExperimentWeight.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')
  # End of ExperimentWeight

  currentMap = abstractTypes.get('ExperimentWeight')
  aList = ['changeIsPositive', 'intensityScale', 'meritThreshold', 'weight']
  currentMap['headerAttrs'] = aList
  aList = ['expCode']
  currentMap['simpleAttrs'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class Mixture
  currentMap = {}
  abstractTypes['Mixture'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00007'] = currentMap
  loadMaps['NMRS.Mixture'] = currentMap
  currentMap['tag'] = 'NMRS.Mixture'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00007'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'mixtures'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.nmr.NmrScreen.Mixture
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute Mixture.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute Mixture.details
  currentMap = {}
  contentMap['details'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00021'] = currentMap
  loadMaps['NMRS.Mixture.details'] = currentMap
  currentMap['tag'] = 'NMRS.Mixture.details'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00021'
  currentMap['name'] = 'details'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute Mixture.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00017'] = currentMap
  loadMaps['NMRS.Mixture.name'] = currentMap
  currentMap['tag'] = 'NMRS.Mixture.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00017'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute Mixture.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00016'] = currentMap
  loadMaps['NMRS.Mixture.serial'] = currentMap
  currentMap['tag'] = 'NMRS.Mixture.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00016'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Role Mixture.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role Mixture.mixtureComponents
  currentMap = {}
  contentMap['mixtureComponents'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00013'] = currentMap
  loadMaps['NMRS.Mixture.mixtureComponents'] = currentMap
  currentMap['tag'] = 'NMRS.Mixture.mixtureComponents'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00013'
  currentMap['name'] = 'mixtureComponents'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('NMRS').get('abstractTypes')

  # Role Mixture.sample
  currentMap = {}
  contentMap['sample'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:57_00001'] = currentMap
  loadMaps['NMRS.Mixture.sample'] = currentMap
  currentMap['tag'] = 'NMRS.Mixture.sample'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:57_00001'
  currentMap['name'] = 'sample'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('SAM').get('exolinks')

  # Role Mixture.trialExperiments
  currentMap = {}
  contentMap['trialExperiments'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-03-28-17:22:44_00002'] = currentMap
  loadMaps['NMRS.Mixture.trialExperiments'] = currentMap
  currentMap['tag'] = 'NMRS.Mixture.trialExperiments'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-03-28-17:22:44_00002'
  currentMap['name'] = 'trialExperiments'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('NMRS').get('abstractTypes')

  # Role Mixture.trials
  currentMap = {}
  contentMap['trials'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00015'] = currentMap
  loadMaps['NMRS.Mixture.trials'] = currentMap
  currentMap['tag'] = 'NMRS.Mixture.trials'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00015'
  currentMap['name'] = 'trials'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['copyOverride'] = True
  # End of Mixture

  currentMap = abstractTypes.get('Mixture')
  aList = ['serial']
  currentMap['headerAttrs'] = aList
  aList = ['details', 'name', 'trials']
  currentMap['simpleAttrs'] = aList
  aList = ['trialExperiments', 'mixtureComponents', 'sample', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['mixtureComponents', 'trialExperiments']
  currentMap['children'] = aList

  # Class MixtureComponent
  currentMap = {}
  abstractTypes['MixtureComponent'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00008'] = currentMap
  loadMaps['NMRS.MixtureComponent'] = currentMap
  currentMap['tag'] = 'NMRS.MixtureComponent'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00008'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'mixtureComponents'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.nmr.NmrScreen.MixtureComponent
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute MixtureComponent.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute MixtureComponent.componentName
  currentMap = {}
  contentMap['componentName'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-03-28-17:22:44_00004'] = currentMap
  loadMaps['NMRS.MixtureComponent.componentName'] = currentMap
  currentMap['tag'] = 'NMRS.MixtureComponent.componentName'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-03-28-17:22:44_00004'
  currentMap['name'] = 'componentName'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute MixtureComponent.componentType
  currentMap = {}
  contentMap['componentType'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-03-28-17:22:44_00005'] = currentMap
  loadMaps['NMRS.MixtureComponent.componentType'] = currentMap
  currentMap['tag'] = 'NMRS.MixtureComponent.componentType'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-03-28-17:22:44_00005'
  currentMap['name'] = 'componentType'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2012-03-28-17:18:50_00001')

  # Attribute MixtureComponent.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00024'] = currentMap
  loadMaps['NMRS.MixtureComponent.serial'] = currentMap
  currentMap['tag'] = 'NMRS.MixtureComponent.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00024'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Role MixtureComponent.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')
  # End of MixtureComponent

  currentMap = abstractTypes.get('MixtureComponent')
  aList = ['componentType', 'serial']
  currentMap['headerAttrs'] = aList
  aList = ['componentName']
  currentMap['simpleAttrs'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class NmrScreen
  currentMap = {}
  abstractTypes['NmrScreen'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00006'] = currentMap
  loadMaps['NMRS.NmrScreen'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00006'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'nmrScreens'
  currentMap['isTop'] = True
  currentMap['objkey'] = 'code'
  currentMap['class'] = ccp.api.nmr.NmrScreen.NmrScreen
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute NmrScreen.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute NmrScreen.code
  currentMap = {}
  contentMap['code'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00034'] = currentMap
  loadMaps['NMRS.NmrScreen.code'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.code'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00034'
  currentMap['name'] = 'code'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037')

  # Attribute NmrScreen.createdBy
  contentMap['createdBy'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:00:59_00002__www.ccpn.ac.uk_Fogh_2007-10-03-14:53:27_00001__www.ccpn.ac.uk_Fogh_2006-09-14-16:28:57_00002')

  # Attribute NmrScreen.details
  currentMap = {}
  contentMap['details'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00040'] = currentMap
  loadMaps['NMRS.NmrScreen.details'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.details'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00040'
  currentMap['name'] = 'details'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute NmrScreen.endDate
  currentMap = {}
  contentMap['endDate'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00039'] = currentMap
  loadMaps['NMRS.NmrScreen.endDate'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.endDate'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00039'
  currentMap['name'] = 'endDate'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['proc'] = 'direct'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00029')

  # Attribute NmrScreen.guid
  contentMap['guid'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:26_00002')

  # Attribute NmrScreen.isModifiable
  contentMap['isModifiable'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-17-14:16:26_00010__www.ccpn.ac.uk_Fogh_2007-10-03-14:53:27_00001__www.ccpn.ac.uk_Fogh_2006-09-14-16:28:57_00002')

  # Attribute NmrScreen.lastUnlockedBy
  contentMap['lastUnlockedBy'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:00:59_00003__www.ccpn.ac.uk_Fogh_2007-10-03-14:53:27_00001__www.ccpn.ac.uk_Fogh_2006-09-14-16:28:57_00002')

  # Attribute NmrScreen.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00035'] = currentMap
  loadMaps['NMRS.NmrScreen.name'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00035'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute NmrScreen.objective
  currentMap = {}
  contentMap['objective'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00037'] = currentMap
  loadMaps['NMRS.NmrScreen.objective'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.objective'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00037'
  currentMap['name'] = 'objective'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute NmrScreen.pH
  currentMap = {}
  contentMap['pH'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-06-13:16:06_00002'] = currentMap
  loadMaps['NMRS.NmrScreen.pH'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.pH'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-06-13:16:06_00002'
  currentMap['name'] = 'pH'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00031')

  # Attribute NmrScreen.refDataStoreNames
  currentMap = {}
  contentMap['refDataStoreNames'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-04-12-17:58:11_00001'] = currentMap
  loadMaps['NMRS.NmrScreen.refDataStoreNames'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.refDataStoreNames'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-04-12-17:58:11_00001'
  currentMap['name'] = 'refDataStoreNames'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute NmrScreen.sampleType
  currentMap = {}
  contentMap['sampleType'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00036'] = currentMap
  loadMaps['NMRS.NmrScreen.sampleType'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.sampleType'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00036'
  currentMap['name'] = 'sampleType'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute NmrScreen.startDate
  currentMap = {}
  contentMap['startDate'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00038'] = currentMap
  loadMaps['NMRS.NmrScreen.startDate'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.startDate'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00038'
  currentMap['name'] = 'startDate'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['proc'] = 'direct'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00029')

  # Attribute NmrScreen.temperature
  currentMap = {}
  contentMap['temperature'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-06-13:16:06_00001'] = currentMap
  loadMaps['NMRS.NmrScreen.temperature'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.temperature'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-06-13:16:06_00001'
  currentMap['name'] = 'temperature'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00009')

  # Attribute NmrScreen.userProtocolCode
  currentMap = {}
  contentMap['userProtocolCode'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-23-11:52:27_00002'] = currentMap
  loadMaps['NMRS.NmrScreen.userProtocolCode'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.userProtocolCode'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-23-11:52:27_00002'
  currentMap['name'] = 'userProtocolCode'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Role NmrScreen.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role NmrScreen.mixtures
  currentMap = {}
  contentMap['mixtures'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00027'] = currentMap
  loadMaps['NMRS.NmrScreen.mixtures'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.mixtures'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00027'
  currentMap['name'] = 'mixtures'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('NMRS').get('abstractTypes')

  # Role NmrScreen.refDataStores
  currentMap = {}
  contentMap['refDataStores'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-03-28-17:22:44_00009'] = currentMap
  loadMaps['NMRS.NmrScreen.refDataStores'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.refDataStores'
  currentMap['type'] = 'exotop'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-03-28-17:22:44_00009'
  currentMap['name'] = 'refDataStores'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('REFD').get('exolinks')

  # Role NmrScreen.target
  currentMap = {}
  contentMap['target'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00033'] = currentMap
  loadMaps['NMRS.NmrScreen.target'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.target'
  currentMap['type'] = 'exotop'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00033'
  currentMap['name'] = 'target'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('MOLS').get('exolinks')

  # Role NmrScreen.trialGroups
  currentMap = {}
  contentMap['trialGroups'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00031'] = currentMap
  loadMaps['NMRS.NmrScreen.trialGroups'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.trialGroups'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00031'
  currentMap['name'] = 'trialGroups'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('NMRS').get('abstractTypes')

  # Role NmrScreen.trialSets
  currentMap = {}
  contentMap['trialSets'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00002'] = currentMap
  loadMaps['NMRS.NmrScreen.trialSets'] = currentMap
  currentMap['tag'] = 'NMRS.NmrScreen.trialSets'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00002'
  currentMap['name'] = 'trialSets'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('NMRS').get('abstractTypes')
  # End of NmrScreen

  currentMap = abstractTypes.get('NmrScreen')
  aList = ['code', 'createdBy', 'guid', 'isModifiable', 'lastUnlockedBy', 'pH', 'temperature']
  currentMap['headerAttrs'] = aList
  aList = ['details', 'endDate', 'name', 'objective', 'refDataStoreNames', 'sampleType', 'startDate', 'userProtocolCode']
  currentMap['simpleAttrs'] = aList
  aList = ['trialSets', 'trialGroups', 'mixtures', 'target', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['mixtures', 'trialGroups', 'trialSets']
  currentMap['children'] = aList

  # Class RegionWeight
  currentMap = {}
  abstractTypes['RegionWeight'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:06_00003'] = currentMap
  loadMaps['NMRS.RegionWeight'] = currentMap
  currentMap['tag'] = 'NMRS.RegionWeight'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:06_00003'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'regionWeights'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.nmr.NmrScreen.RegionWeight
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute RegionWeight.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute RegionWeight.maxPpm
  currentMap = {}
  contentMap['maxPpm'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00005'] = currentMap
  loadMaps['NMRS.RegionWeight.maxPpm'] = currentMap
  currentMap['tag'] = 'NMRS.RegionWeight.maxPpm'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00005'
  currentMap['name'] = 'maxPpm'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00031')

  # Attribute RegionWeight.minPpm
  currentMap = {}
  contentMap['minPpm'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00004'] = currentMap
  loadMaps['NMRS.RegionWeight.minPpm'] = currentMap
  currentMap['tag'] = 'NMRS.RegionWeight.minPpm'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00004'
  currentMap['name'] = 'minPpm'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00031')

  # Attribute RegionWeight.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00003'] = currentMap
  loadMaps['NMRS.RegionWeight.serial'] = currentMap
  currentMap['tag'] = 'NMRS.RegionWeight.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00003'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute RegionWeight.weight
  currentMap = {}
  contentMap['weight'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00006'] = currentMap
  loadMaps['NMRS.RegionWeight.weight'] = currentMap
  currentMap['tag'] = 'NMRS.RegionWeight.weight'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00006'
  currentMap['name'] = 'weight'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00009')

  # Role RegionWeight.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')
  # End of RegionWeight

  currentMap = abstractTypes.get('RegionWeight')
  aList = ['maxPpm', 'minPpm', 'serial', 'weight']
  currentMap['headerAttrs'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class Trial
  currentMap = {}
  abstractTypes['Trial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00009'] = currentMap
  loadMaps['NMRS.Trial'] = currentMap
  currentMap['tag'] = 'NMRS.Trial'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00009'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'trials'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.nmr.NmrScreen.Trial
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute Trial.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute Trial.date
  currentMap = {}
  contentMap['date'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00009'] = currentMap
  loadMaps['NMRS.Trial.date'] = currentMap
  currentMap['tag'] = 'NMRS.Trial.date'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00009'
  currentMap['name'] = 'date'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['proc'] = 'direct'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00029')

  # Attribute Trial.details
  currentMap = {}
  contentMap['details'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00010'] = currentMap
  loadMaps['NMRS.Trial.details'] = currentMap
  currentMap['tag'] = 'NMRS.Trial.details'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00010'
  currentMap['name'] = 'details'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute Trial.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00008'] = currentMap
  loadMaps['NMRS.Trial.name'] = currentMap
  currentMap['tag'] = 'NMRS.Trial.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00008'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute Trial.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00007'] = currentMap
  loadMaps['NMRS.Trial.serial'] = currentMap
  currentMap['tag'] = 'NMRS.Trial.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00007'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Role Trial.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role Trial.mixtures
  currentMap = {}
  contentMap['mixtures'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00014'] = currentMap
  loadMaps['NMRS.Trial.mixtures'] = currentMap
  currentMap['tag'] = 'NMRS.Trial.mixtures'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00014'
  currentMap['name'] = 'mixtures'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['copyOverride'] = True

  # Role Trial.trialGroups
  currentMap = {}
  contentMap['trialGroups'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00004'] = currentMap
  loadMaps['NMRS.Trial.trialGroups'] = currentMap
  currentMap['tag'] = 'NMRS.Trial.trialGroups'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00004'
  currentMap['name'] = 'trialGroups'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['copyOverride'] = True

  # Role Trial.trialHits
  currentMap = {}
  contentMap['trialHits'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00002'] = currentMap
  loadMaps['NMRS.Trial.trialHits'] = currentMap
  currentMap['tag'] = 'NMRS.Trial.trialHits'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00002'
  currentMap['name'] = 'trialHits'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('NMRS').get('abstractTypes')
  # End of Trial

  currentMap = abstractTypes.get('Trial')
  aList = ['serial']
  currentMap['headerAttrs'] = aList
  aList = ['date', 'details', 'name', 'mixtures', 'trialGroups']
  currentMap['simpleAttrs'] = aList
  aList = ['trialHits', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['trialHits']
  currentMap['children'] = aList

  # Class TrialExperiment
  currentMap = {}
  abstractTypes['TrialExperiment'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00012'] = currentMap
  loadMaps['NMRS.TrialExperiment'] = currentMap
  currentMap['tag'] = 'NMRS.TrialExperiment'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00012'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'trialExperiments'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.nmr.NmrScreen.TrialExperiment
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute TrialExperiment.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute TrialExperiment.details
  currentMap = {}
  contentMap['details'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00015'] = currentMap
  loadMaps['NMRS.TrialExperiment.details'] = currentMap
  currentMap['tag'] = 'NMRS.TrialExperiment.details'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00015'
  currentMap['name'] = 'details'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute TrialExperiment.expCode
  currentMap = {}
  contentMap['expCode'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00007'] = currentMap
  loadMaps['NMRS.TrialExperiment.expCode'] = currentMap
  currentMap['tag'] = 'NMRS.TrialExperiment.expCode'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00007'
  currentMap['name'] = 'expCode'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2012-05-21-18:09:06_00001')

  # Attribute TrialExperiment.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00014'] = currentMap
  loadMaps['NMRS.TrialExperiment.name'] = currentMap
  currentMap['tag'] = 'NMRS.TrialExperiment.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00014'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute TrialExperiment.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00013'] = currentMap
  loadMaps['NMRS.TrialExperiment.serial'] = currentMap
  currentMap['tag'] = 'NMRS.TrialExperiment.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00013'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Role TrialExperiment.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role TrialExperiment.dataSources
  currentMap = {}
  contentMap['dataSources'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00012'] = currentMap
  loadMaps['NMRS.TrialExperiment.dataSources'] = currentMap
  currentMap['tag'] = 'NMRS.TrialExperiment.dataSources'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00012'
  currentMap['name'] = 'dataSources'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role TrialExperiment.experimentHits
  currentMap = {}
  contentMap['experimentHits'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00008'] = currentMap
  loadMaps['NMRS.TrialExperiment.experimentHits'] = currentMap
  currentMap['tag'] = 'NMRS.TrialExperiment.experimentHits'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:38_00008'
  currentMap['name'] = 'experimentHits'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['copyOverride'] = False
  # End of TrialExperiment

  currentMap = abstractTypes.get('TrialExperiment')
  aList = ['serial']
  currentMap['headerAttrs'] = aList
  aList = ['details', 'expCode', 'name', 'experimentHits']
  currentMap['simpleAttrs'] = aList
  aList = ['dataSources', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class TrialGroup
  currentMap = {}
  abstractTypes['TrialGroup'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00011'] = currentMap
  loadMaps['NMRS.TrialGroup'] = currentMap
  currentMap['tag'] = 'NMRS.TrialGroup'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00011'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'trialGroups'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.nmr.NmrScreen.TrialGroup
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute TrialGroup.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute TrialGroup.details
  currentMap = {}
  contentMap['details'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00018'] = currentMap
  loadMaps['NMRS.TrialGroup.details'] = currentMap
  currentMap['tag'] = 'NMRS.TrialGroup.details'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00018'
  currentMap['name'] = 'details'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute TrialGroup.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00017'] = currentMap
  loadMaps['NMRS.TrialGroup.name'] = currentMap
  currentMap['tag'] = 'NMRS.TrialGroup.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00017'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute TrialGroup.phaseType
  currentMap = {}
  contentMap['phaseType'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00019'] = currentMap
  loadMaps['NMRS.TrialGroup.phaseType'] = currentMap
  currentMap['tag'] = 'NMRS.TrialGroup.phaseType'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00019'
  currentMap['name'] = 'phaseType'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute TrialGroup.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00016'] = currentMap
  loadMaps['NMRS.TrialGroup.serial'] = currentMap
  currentMap['tag'] = 'NMRS.TrialGroup.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00016'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Role TrialGroup.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role TrialGroup.trials
  currentMap = {}
  contentMap['trials'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00003'] = currentMap
  loadMaps['NMRS.TrialGroup.trials'] = currentMap
  currentMap['tag'] = 'NMRS.TrialGroup.trials'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00003'
  currentMap['name'] = 'trials'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['copyOverride'] = True
  # End of TrialGroup

  currentMap = abstractTypes.get('TrialGroup')
  aList = ['serial']
  currentMap['headerAttrs'] = aList
  aList = ['details', 'name', 'phaseType', 'trials']
  currentMap['simpleAttrs'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class TrialHit
  currentMap = {}
  abstractTypes['TrialHit'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00010'] = currentMap
  loadMaps['NMRS.TrialHit'] = currentMap
  currentMap['tag'] = 'NMRS.TrialHit'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00010'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'trialHits'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.nmr.NmrScreen.TrialHit
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute TrialHit.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute TrialHit.componentName
  currentMap = {}
  contentMap['componentName'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-03-28-17:22:44_00011'] = currentMap
  loadMaps['NMRS.TrialHit.componentName'] = currentMap
  currentMap['tag'] = 'NMRS.TrialHit.componentName'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-03-28-17:22:44_00011'
  currentMap['name'] = 'componentName'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute TrialHit.details
  currentMap = {}
  contentMap['details'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00025'] = currentMap
  loadMaps['NMRS.TrialHit.details'] = currentMap
  currentMap['tag'] = 'NMRS.TrialHit.details'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00025'
  currentMap['name'] = 'details'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute TrialHit.figOfMerit
  currentMap = {}
  contentMap['figOfMerit'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00023'] = currentMap
  loadMaps['NMRS.TrialHit.figOfMerit'] = currentMap
  currentMap['tag'] = 'NMRS.TrialHit.figOfMerit'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00023'
  currentMap['name'] = 'figOfMerit'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00058')

  # Attribute TrialHit.hasBeenInspected
  currentMap = {}
  contentMap['hasBeenInspected'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-18-12:04:57_00002'] = currentMap
  loadMaps['NMRS.TrialHit.hasBeenInspected'] = currentMap
  currentMap['tag'] = 'NMRS.TrialHit.hasBeenInspected'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-18-12:04:57_00002'
  currentMap['name'] = 'hasBeenInspected'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute TrialHit.isConfirmed
  currentMap = {}
  contentMap['isConfirmed'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-18-12:04:57_00001'] = currentMap
  loadMaps['NMRS.TrialHit.isConfirmed'] = currentMap
  currentMap['tag'] = 'NMRS.TrialHit.isConfirmed'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-18-12:04:57_00001'
  currentMap['name'] = 'isConfirmed'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute TrialHit.meritCode
  currentMap = {}
  contentMap['meritCode'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00024'] = currentMap
  loadMaps['NMRS.TrialHit.meritCode'] = currentMap
  currentMap['tag'] = 'NMRS.TrialHit.meritCode'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00024'
  currentMap['name'] = 'meritCode'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037')

  # Attribute TrialHit.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00022'] = currentMap
  loadMaps['NMRS.TrialHit.serial'] = currentMap
  currentMap['tag'] = 'NMRS.TrialHit.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00022'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Role TrialHit.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role TrialHit.experimentHits
  currentMap = {}
  contentMap['experimentHits'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00021'] = currentMap
  loadMaps['NMRS.TrialHit.experimentHits'] = currentMap
  currentMap['tag'] = 'NMRS.TrialHit.experimentHits'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:51:56_00021'
  currentMap['name'] = 'experimentHits'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('NMRS').get('abstractTypes')

  # Role TrialHit.refNmrSpectra
  currentMap = {}
  contentMap['refNmrSpectra'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-03-29-15:58:32_00001'] = currentMap
  loadMaps['NMRS.TrialHit.refNmrSpectra'] = currentMap
  currentMap['tag'] = 'NMRS.TrialHit.refNmrSpectra'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-03-29-15:58:32_00001'
  currentMap['name'] = 'refNmrSpectra'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('REFD').get('exolinks')
  # End of TrialHit

  currentMap = abstractTypes.get('TrialHit')
  aList = ['figOfMerit', 'isConfirmed', 'meritCode', 'serial']
  currentMap['headerAttrs'] = aList
  aList = ['componentName', 'details']
  currentMap['simpleAttrs'] = aList
  aList = ['experimentHits', 'refNmrSpectra', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['experimentHits']
  currentMap['children'] = aList

  # Class TrialSet
  currentMap = {}
  abstractTypes['TrialSet'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:06_00002'] = currentMap
  loadMaps['NMRS.TrialSet'] = currentMap
  currentMap['tag'] = 'NMRS.TrialSet'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:06_00002'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'trialSets'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccp.api.nmr.NmrScreen.TrialSet
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute TrialSet.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute TrialSet.details
  currentMap = {}
  contentMap['details'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00016'] = currentMap
  loadMaps['NMRS.TrialSet.details'] = currentMap
  currentMap['tag'] = 'NMRS.TrialSet.details'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00016'
  currentMap['name'] = 'details'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00036')

  # Attribute TrialSet.evaluateOnlyUnambiguous
  currentMap = {}
  contentMap['evaluateOnlyUnambiguous'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-16-12:06:02_00001'] = currentMap
  loadMaps['NMRS.TrialSet.evaluateOnlyUnambiguous'] = currentMap
  currentMap['tag'] = 'NMRS.TrialSet.evaluateOnlyUnambiguous'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-16-12:06:02_00001'
  currentMap['name'] = 'evaluateOnlyUnambiguous'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute TrialSet.evaluateSingleResonance
  currentMap = {}
  contentMap['evaluateSingleResonance'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00008'] = currentMap
  loadMaps['NMRS.TrialSet.evaluateSingleResonance'] = currentMap
  currentMap['tag'] = 'NMRS.TrialSet.evaluateSingleResonance'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00008'
  currentMap['name'] = 'evaluateSingleResonance'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute TrialSet.identifyAllosteric
  currentMap = {}
  contentMap['identifyAllosteric'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00007'] = currentMap
  loadMaps['NMRS.TrialSet.identifyAllosteric'] = currentMap
  currentMap['tag'] = 'NMRS.TrialSet.identifyAllosteric'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00007'
  currentMap['name'] = 'identifyAllosteric'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute TrialSet.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00013'] = currentMap
  loadMaps['NMRS.TrialSet.name'] = currentMap
  currentMap['tag'] = 'NMRS.TrialSet.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00013'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute TrialSet.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00012'] = currentMap
  loadMaps['NMRS.TrialSet.serial'] = currentMap
  currentMap['tag'] = 'NMRS.TrialSet.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00012'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute TrialSet.useInverseEffects
  currentMap = {}
  contentMap['useInverseEffects'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00014'] = currentMap
  loadMaps['NMRS.TrialSet.useInverseEffects'] = currentMap
  currentMap['tag'] = 'NMRS.TrialSet.useInverseEffects'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00014'
  currentMap['name'] = 'useInverseEffects'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute TrialSet.useVolume
  currentMap = {}
  contentMap['useVolume'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00015'] = currentMap
  loadMaps['NMRS.TrialSet.useVolume'] = currentMap
  currentMap['tag'] = 'NMRS.TrialSet.useVolume'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00015'
  currentMap['name'] = 'useVolume'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Role TrialSet.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role TrialSet.experimentWeights
  currentMap = {}
  contentMap['experimentWeights'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00006'] = currentMap
  loadMaps['NMRS.TrialSet.experimentWeights'] = currentMap
  currentMap['tag'] = 'NMRS.TrialSet.experimentWeights'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-06-13:03:50_00006'
  currentMap['name'] = 'experimentWeights'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('NMRS').get('abstractTypes')

  # Role TrialSet.regionWeights
  currentMap = {}
  contentMap['regionWeights'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00011'] = currentMap
  loadMaps['NMRS.TrialSet.regionWeights'] = currentMap
  currentMap['tag'] = 'NMRS.TrialSet.regionWeights'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00011'
  currentMap['name'] = 'regionWeights'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('NMRS').get('abstractTypes')

  # Role TrialSet.trials
  currentMap = {}
  contentMap['trials'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00009'] = currentMap
  loadMaps['NMRS.TrialSet.trials'] = currentMap
  currentMap['tag'] = 'NMRS.TrialSet.trials'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:12_00009'
  currentMap['name'] = 'trials'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('NMRS').get('abstractTypes')
  # End of TrialSet

  currentMap = abstractTypes.get('TrialSet')
  aList = ['evaluateOnlyUnambiguous', 'evaluateSingleResonance', 'identifyAllosteric', 'serial', 'useInverseEffects', 'useVolume']
  currentMap['headerAttrs'] = aList
  aList = ['details', 'name']
  currentMap['simpleAttrs'] = aList
  aList = ['trials', 'regionWeights', 'experimentWeights', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['experimentWeights', 'regionWeights', 'trials']
  currentMap['children'] = aList

  # Out-of-package link to ExperimentHit
  currentMap = {}
  exolinks['ExperimentHit'] = currentMap
  loadMaps['NMRS.exo-ExperimentHit'] = currentMap
  currentMap['tag'] = 'NMRS.exo-ExperimentHit'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00013'
  currentMap['name'] = 'ExperimentHit'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.nmr.NmrScreen.ExperimentHit
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(globalMap.get('NMRS').get('exolinks'))

  # Out-of-package link to ExperimentWeight
  currentMap = {}
  exolinks['ExperimentWeight'] = currentMap
  loadMaps['NMRS.exo-ExperimentWeight'] = currentMap
  currentMap['tag'] = 'NMRS.exo-ExperimentWeight'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-07-06-13:03:44_00001'
  currentMap['name'] = 'ExperimentWeight'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.nmr.NmrScreen.ExperimentWeight
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2012-05-21-18:09:06_00001'))

  # Out-of-package link to Mixture
  currentMap = {}
  exolinks['Mixture'] = currentMap
  loadMaps['NMRS.exo-Mixture'] = currentMap
  currentMap['tag'] = 'NMRS.exo-Mixture'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00007'
  currentMap['name'] = 'Mixture'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.nmr.NmrScreen.Mixture
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to MixtureComponent
  currentMap = {}
  exolinks['MixtureComponent'] = currentMap
  loadMaps['NMRS.exo-MixtureComponent'] = currentMap
  currentMap['tag'] = 'NMRS.exo-MixtureComponent'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00008'
  currentMap['name'] = 'MixtureComponent'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.nmr.NmrScreen.MixtureComponent
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to NmrScreen
  currentMap = {}
  exolinks['NmrScreen'] = currentMap
  loadMaps['NMRS.exo-NmrScreen'] = currentMap
  currentMap['tag'] = 'NMRS.exo-NmrScreen'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00006'
  currentMap['name'] = 'NmrScreen'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.nmr.NmrScreen.NmrScreen
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))

  # Out-of-package link to RegionWeight
  currentMap = {}
  exolinks['RegionWeight'] = currentMap
  loadMaps['NMRS.exo-RegionWeight'] = currentMap
  currentMap['tag'] = 'NMRS.exo-RegionWeight'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:06_00003'
  currentMap['name'] = 'RegionWeight'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.nmr.NmrScreen.RegionWeight
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to Trial
  currentMap = {}
  exolinks['Trial'] = currentMap
  loadMaps['NMRS.exo-Trial'] = currentMap
  currentMap['tag'] = 'NMRS.exo-Trial'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00009'
  currentMap['name'] = 'Trial'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.nmr.NmrScreen.Trial
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to TrialExperiment
  currentMap = {}
  exolinks['TrialExperiment'] = currentMap
  loadMaps['NMRS.exo-TrialExperiment'] = currentMap
  currentMap['tag'] = 'NMRS.exo-TrialExperiment'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00012'
  currentMap['name'] = 'TrialExperiment'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.nmr.NmrScreen.TrialExperiment
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to TrialGroup
  currentMap = {}
  exolinks['TrialGroup'] = currentMap
  loadMaps['NMRS.exo-TrialGroup'] = currentMap
  currentMap['tag'] = 'NMRS.exo-TrialGroup'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00011'
  currentMap['name'] = 'TrialGroup'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.nmr.NmrScreen.TrialGroup
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to TrialHit
  currentMap = {}
  exolinks['TrialHit'] = currentMap
  loadMaps['NMRS.exo-TrialHit'] = currentMap
  currentMap['tag'] = 'NMRS.exo-TrialHit'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2009-11-19-14:50:32_00010'
  currentMap['name'] = 'TrialHit'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.nmr.NmrScreen.TrialHit
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to TrialSet
  currentMap = {}
  exolinks['TrialSet'] = currentMap
  loadMaps['NMRS.exo-TrialSet'] = currentMap
  currentMap['tag'] = 'NMRS.exo-TrialSet'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:06_00002'
  currentMap['name'] = 'TrialSet'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccp.api.nmr.NmrScreen.TrialSet
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
