"""
#######################################################################

CCPN Data Model version 2.1.2

Autogenerated by PyXmlMapWrite revision 1.29 on Mon Mar  2 17:24:14 2015
  from data model element ccpnmr.AnalysisV3 revision ?

#######################################################################
======================COPYRIGHT/LICENSE START==========================

AnalysisV3.py: python XML-I/O-mapping for CCPN data model, MetaPackage ccpnmr.AnalysisV3

Copyright (C) 2007  (CCPN Project)

=======================================================================

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.
 
A copy of this license can be found in ../../../license/LGPL.license
 
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
 
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


======================COPYRIGHT/LICENSE END============================

for further information, please contact :

- CCPN website (http://www.ccpn.ac.uk/)

- email: ccpn@bioc.cam.ac.uk

=======================================================================

If you are using this software for academic purposes, we suggest
quoting the following references:

===========================REFERENCE START=============================
Rasmus H. Fogh, Wayne Boucher, Wim F. Vranken, Anne
Pajon, Tim J. Stevens, T.N. Bhat, John Westbrook, John M.C. Ionides and
Ernest D. Laue (2005). A framework for scientific data modeling and automated
software development. Bioinformatics 21, 1678-1684.


This file was generated with the Memops software generation framework,
and contains original contributions embedded in the framework

===========================REFERENCE END===============================
"""
from memops.general.Constants import baseDataTypeModule as basicDataTypes
# 
#  Current package api
import ccpnmr.api.AnalysisV3

def makeMapping(globalMap):
  """
  generates XML I/O mapping for package ANA3, adding it to globalMap
  """
  
  from memops.xml.Implementation import bool2str, str2bool

  # Set up top level dictionaries
  loadMaps = globalMap.get('loadMaps')
  mapsByGuid = globalMap.get('mapsByGuid')

  abstractTypes = globalMap.get('ANA3').get('abstractTypes')
  exolinks = globalMap.get('ANA3').get('exolinks')

  # Class AnalysisDataDim
  currentMap = {}
  abstractTypes['AnalysisDataDim'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00001'] = currentMap
  loadMaps['ANA3.AnalysisDataDim'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisDataDim'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00001'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'analysisDataDims'
  currentMap['objkey'] = 'dataDim'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnalysisDataDim
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute AnalysisDataDim.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute AnalysisDataDim.assignTolerance
  currentMap = {}
  contentMap['assignTolerance'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00005'] = currentMap
  loadMaps['ANA3.AnalysisDataDim.assignTolerance'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisDataDim.assignTolerance'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00005'
  currentMap['name'] = 'assignTolerance'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 0.1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00009')

  # Attribute AnalysisDataDim.chemShiftWeight
  currentMap = {}
  contentMap['chemShiftWeight'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00006'] = currentMap
  loadMaps['ANA3.AnalysisDataDim.chemShiftWeight'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisDataDim.chemShiftWeight'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00006'
  currentMap['name'] = 'chemShiftWeight'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00009')

  # Attribute AnalysisDataDim.noeTolerance
  currentMap = {}
  contentMap['noeTolerance'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00007'] = currentMap
  loadMaps['ANA3.AnalysisDataDim.noeTolerance'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisDataDim.noeTolerance'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00007'
  currentMap['name'] = 'noeTolerance'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 0.1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00009')

  # Attribute AnalysisDataDim.peakFindBoxwidth
  currentMap = {}
  contentMap['peakFindBoxwidth'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00008'] = currentMap
  loadMaps['ANA3.AnalysisDataDim.peakFindBoxwidth'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisDataDim.peakFindBoxwidth'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00008'
  currentMap['name'] = 'peakFindBoxwidth'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00009')

  # Attribute AnalysisDataDim.peakFindMinLineWIdth
  currentMap = {}
  contentMap['peakFindMinLineWIdth'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00009'] = currentMap
  loadMaps['ANA3.AnalysisDataDim.peakFindMinLineWIdth'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisDataDim.peakFindMinLineWIdth'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00009'
  currentMap['name'] = 'peakFindMinLineWIdth'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 0.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00009')

  # Attribute AnalysisDataDim.refSamplePlane
  currentMap = {}
  contentMap['refSamplePlane'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00010'] = currentMap
  loadMaps['ANA3.AnalysisDataDim.refSamplePlane'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisDataDim.refSamplePlane'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00010'
  currentMap['name'] = 'refSamplePlane'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00009')

  # Role AnalysisDataDim.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role AnalysisDataDim.axisMappings
  currentMap = {}
  contentMap['axisMappings'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00004'] = currentMap
  loadMaps['ANA3.AnalysisDataDim.axisMappings'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisDataDim.axisMappings'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00004'
  currentMap['name'] = 'axisMappings'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['copyOverride'] = False

  # Role AnalysisDataDim.dataDim
  currentMap = {}
  contentMap['dataDim'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00002'] = currentMap
  loadMaps['ANA3.AnalysisDataDim.dataDim'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisDataDim.dataDim'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00002'
  currentMap['name'] = 'dataDim'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')
  # End of AnalysisDataDim

  currentMap = abstractTypes.get('AnalysisDataDim')
  aList = ['assignTolerance', 'chemShiftWeight', 'noeTolerance', 'peakFindBoxwidth', 'peakFindMinLineWIdth', 'refSamplePlane']
  currentMap['headerAttrs'] = aList
  aList = ['axisMappings']
  currentMap['simpleAttrs'] = aList
  aList = ['dataDim', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class AnalysisLayout
  currentMap = {}
  abstractTypes['AnalysisLayout'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:29_00001'] = currentMap
  loadMaps['ANA3.AnalysisLayout'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisLayout'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:29_00001'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'analysisLayouts'
  currentMap['objkey'] = 'layout'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnalysisLayout
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute AnalysisLayout.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Role AnalysisLayout.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role AnalysisLayout.currentChains
  currentMap = {}
  contentMap['currentChains'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00008'] = currentMap
  loadMaps['ANA3.AnalysisLayout.currentChains'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisLayout.currentChains'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00008'
  currentMap['name'] = 'currentChains'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('MOLS').get('exolinks')

  # Role AnalysisLayout.currentMolSystem
  currentMap = {}
  contentMap['currentMolSystem'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00006'] = currentMap
  loadMaps['ANA3.AnalysisLayout.currentMolSystem'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisLayout.currentMolSystem'
  currentMap['type'] = 'exotop'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00006'
  currentMap['name'] = 'currentMolSystem'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('MOLS').get('exolinks')

  # Role AnalysisLayout.currentPeakLists
  currentMap = {}
  contentMap['currentPeakLists'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00018'] = currentMap
  loadMaps['ANA3.AnalysisLayout.currentPeakLists'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisLayout.currentPeakLists'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00018'
  currentMap['name'] = 'currentPeakLists'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisLayout.currentPeaks
  currentMap = {}
  contentMap['currentPeaks'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00016'] = currentMap
  loadMaps['ANA3.AnalysisLayout.currentPeaks'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisLayout.currentPeaks'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00016'
  currentMap['name'] = 'currentPeaks'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisLayout.currentResonances
  currentMap = {}
  contentMap['currentResonances'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00012'] = currentMap
  loadMaps['ANA3.AnalysisLayout.currentResonances'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisLayout.currentResonances'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00012'
  currentMap['name'] = 'currentResonances'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisLayout.currentRestraintSet
  currentMap = {}
  contentMap['currentRestraintSet'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00014'] = currentMap
  loadMaps['ANA3.AnalysisLayout.currentRestraintSet'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisLayout.currentRestraintSet'
  currentMap['type'] = 'exotop'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00014'
  currentMap['name'] = 'currentRestraintSet'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMRC').get('exolinks')

  # Role AnalysisLayout.currentSpectra
  currentMap = {}
  contentMap['currentSpectra'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00020'] = currentMap
  loadMaps['ANA3.AnalysisLayout.currentSpectra'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisLayout.currentSpectra'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00020'
  currentMap['name'] = 'currentSpectra'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisLayout.currentSpinSystems
  currentMap = {}
  contentMap['currentSpinSystems'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00010'] = currentMap
  loadMaps['ANA3.AnalysisLayout.currentSpinSystems'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisLayout.currentSpinSystems'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00010'
  currentMap['name'] = 'currentSpinSystems'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisLayout.currentStructures
  currentMap = {}
  contentMap['currentStructures'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00004'] = currentMap
  loadMaps['ANA3.AnalysisLayout.currentStructures'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisLayout.currentStructures'
  currentMap['type'] = 'exotop'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00004'
  currentMap['name'] = 'currentStructures'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('COOR').get('exolinks')

  # Role AnalysisLayout.layout
  currentMap = {}
  contentMap['layout'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00002'] = currentMap
  loadMaps['ANA3.AnalysisLayout.layout'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisLayout.layout'
  currentMap['type'] = 'exotop'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00002'
  currentMap['name'] = 'layout'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('ANAY').get('exolinks')
  # End of AnalysisLayout

  currentMap = abstractTypes.get('AnalysisLayout')
  aList = ['layout', 'currentStructures', 'currentSpinSystems', 'currentSpectra', 'currentRestraintSet', 'currentResonances', 'currentPeaks', 'currentPeakLists', 'currentMolSystem', 'currentChains', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class AnalysisPanel
  currentMap = {}
  abstractTypes['AnalysisPanel'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:29_00002'] = currentMap
  loadMaps['ANA3.AnalysisPanel'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPanel'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:29_00002'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'analysisPanels'
  currentMap['objkey'] = 'panel'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnalysisPanel
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute AnalysisPanel.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Role AnalysisPanel.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role AnalysisPanel.currentChains
  currentMap = {}
  contentMap['currentChains'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00036'] = currentMap
  loadMaps['ANA3.AnalysisPanel.currentChains'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPanel.currentChains'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00036'
  currentMap['name'] = 'currentChains'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = False
  currentMap['content'] = globalMap.get('MOLS').get('exolinks')

  # Role AnalysisPanel.currentMolSystem
  currentMap = {}
  contentMap['currentMolSystem'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00038'] = currentMap
  loadMaps['ANA3.AnalysisPanel.currentMolSystem'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPanel.currentMolSystem'
  currentMap['type'] = 'exotop'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00038'
  currentMap['name'] = 'currentMolSystem'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('MOLS').get('exolinks')

  # Role AnalysisPanel.currentPeakLists
  currentMap = {}
  contentMap['currentPeakLists'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00026'] = currentMap
  loadMaps['ANA3.AnalysisPanel.currentPeakLists'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPanel.currentPeakLists'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00026'
  currentMap['name'] = 'currentPeakLists'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisPanel.currentPeaks
  currentMap = {}
  contentMap['currentPeaks'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00028'] = currentMap
  loadMaps['ANA3.AnalysisPanel.currentPeaks'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPanel.currentPeaks'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00028'
  currentMap['name'] = 'currentPeaks'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisPanel.currentResonances
  currentMap = {}
  contentMap['currentResonances'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00032'] = currentMap
  loadMaps['ANA3.AnalysisPanel.currentResonances'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPanel.currentResonances'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00032'
  currentMap['name'] = 'currentResonances'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisPanel.currentRestraintSet
  currentMap = {}
  contentMap['currentRestraintSet'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00030'] = currentMap
  loadMaps['ANA3.AnalysisPanel.currentRestraintSet'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPanel.currentRestraintSet'
  currentMap['type'] = 'exotop'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00030'
  currentMap['name'] = 'currentRestraintSet'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMRC').get('exolinks')

  # Role AnalysisPanel.currentSpectra
  currentMap = {}
  contentMap['currentSpectra'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00024'] = currentMap
  loadMaps['ANA3.AnalysisPanel.currentSpectra'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPanel.currentSpectra'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00024'
  currentMap['name'] = 'currentSpectra'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisPanel.currentSpinSystems
  currentMap = {}
  contentMap['currentSpinSystems'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00034'] = currentMap
  loadMaps['ANA3.AnalysisPanel.currentSpinSystems'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPanel.currentSpinSystems'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00034'
  currentMap['name'] = 'currentSpinSystems'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisPanel.currentStructures
  currentMap = {}
  contentMap['currentStructures'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00040'] = currentMap
  loadMaps['ANA3.AnalysisPanel.currentStructures'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPanel.currentStructures'
  currentMap['type'] = 'exotop'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00040'
  currentMap['name'] = 'currentStructures'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('COOR').get('exolinks')

  # Role AnalysisPanel.panel
  currentMap = {}
  contentMap['panel'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00022'] = currentMap
  loadMaps['ANA3.AnalysisPanel.panel'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPanel.panel'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00022'
  currentMap['name'] = 'panel'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('ANAY').get('exolinks')
  # End of AnalysisPanel

  currentMap = abstractTypes.get('AnalysisPanel')
  aList = ['panel', 'currentStructures', 'currentSpinSystems', 'currentSpectra', 'currentRestraintSet', 'currentResonances', 'currentPeaks', 'currentPeakLists', 'currentMolSystem', 'currentChains', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class AnalysisPeakList
  currentMap = {}
  abstractTypes['AnalysisPeakList'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00002'] = currentMap
  loadMaps['ANA3.AnalysisPeakList'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPeakList'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00002'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'analysisPeakLists'
  currentMap['objkey'] = 'peakList'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnalysisPeakList
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute AnalysisPeakList.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute AnalysisPeakList.noeIntensityType
  currentMap = {}
  contentMap['noeIntensityType'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00013'] = currentMap
  loadMaps['ANA3.AnalysisPeakList.noeIntensityType'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPeakList.noeIntensityType'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00013'
  currentMap['name'] = 'noeIntensityType'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 'height'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037')

  # Attribute AnalysisPeakList.noeRefDistance
  currentMap = {}
  contentMap['noeRefDistance'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00014'] = currentMap
  loadMaps['ANA3.AnalysisPeakList.noeRefDistance'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPeakList.noeRefDistance'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00014'
  currentMap['name'] = 'noeRefDistance'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 3.2
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00007')

  # Attribute AnalysisPeakList.noeRefIntensity
  currentMap = {}
  contentMap['noeRefIntensity'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00015'] = currentMap
  loadMaps['ANA3.AnalysisPeakList.noeRefIntensity'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPeakList.noeRefIntensity'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00015'
  currentMap['name'] = 'noeRefIntensity'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00007')

  # Attribute AnalysisPeakList.symbolColor
  currentMap = {}
  contentMap['symbolColor'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00017'] = currentMap
  loadMaps['ANA3.AnalysisPeakList.symbolColor'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPeakList.symbolColor'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00017'
  currentMap['name'] = 'symbolColor'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['default'] = '#808080FF'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2011-12-02-09:49:50_00003')

  # Attribute AnalysisPeakList.symbolStyle
  currentMap = {}
  contentMap['symbolStyle'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00016'] = currentMap
  loadMaps['ANA3.AnalysisPeakList.symbolStyle'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPeakList.symbolStyle'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00016'
  currentMap['name'] = 'symbolStyle'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 'x'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-05-05-18:37:53_00002')

  # Attribute AnalysisPeakList.textColor
  currentMap = {}
  contentMap['textColor'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00018'] = currentMap
  loadMaps['ANA3.AnalysisPeakList.textColor'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPeakList.textColor'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00018'
  currentMap['name'] = 'textColor'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['default'] = '#808080FF'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2011-12-02-09:49:50_00003')

  # Role AnalysisPeakList.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role AnalysisPeakList.peakList
  currentMap = {}
  contentMap['peakList'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-11:04:36_00003'] = currentMap
  loadMaps['ANA3.AnalysisPeakList.peakList'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPeakList.peakList'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-11:04:36_00003'
  currentMap['name'] = 'peakList'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisPeakList.peakListViews
  currentMap = {}
  contentMap['peakListViews'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00012'] = currentMap
  loadMaps['ANA3.AnalysisPeakList.peakListViews'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisPeakList.peakListViews'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00012'
  currentMap['name'] = 'peakListViews'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['copyOverride'] = False
  # End of AnalysisPeakList

  currentMap = abstractTypes.get('AnalysisPeakList')
  aList = ['noeIntensityType', 'noeRefDistance', 'noeRefIntensity', 'symbolStyle']
  currentMap['headerAttrs'] = aList
  aList = ['symbolColor', 'textColor', 'peakListViews']
  currentMap['simpleAttrs'] = aList
  aList = ['peakList', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class AnalysisProjectV3
  currentMap = {}
  abstractTypes['AnalysisProjectV3'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00002'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00002'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'analysisProjectV3s'
  currentMap['isTop'] = True
  currentMap['objkey'] = 'name'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnalysisProjectV3
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute AnalysisProjectV3.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute AnalysisProjectV3.autoBackupFreq
  currentMap = {}
  contentMap['autoBackupFreq'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00031'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.autoBackupFreq'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.autoBackupFreq'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00031'
  currentMap['name'] = 'autoBackupFreq'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00001')

  # Attribute AnalysisProjectV3.contourToUnaliased
  currentMap = {}
  contentMap['contourToUnaliased'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00032'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.contourToUnaliased'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.contourToUnaliased'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00032'
  currentMap['name'] = 'contourToUnaliased'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute AnalysisProjectV3.createdBy
  contentMap['createdBy'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:00:59_00002__www.ccpn.ac.uk_Fogh_2007-10-03-14:53:27_00001__www.ccpn.ac.uk_Fogh_2006-09-14-16:28:57_00002')

  # Attribute AnalysisProjectV3.details
  currentMap = {}
  contentMap['details'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-04-13-13:40:40_00002'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.details'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.details'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-04-13-13:40:40_00002'
  currentMap['name'] = 'details'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['proc'] = 'direct'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00035')

  # Attribute AnalysisProjectV3.globalContourScale
  currentMap = {}
  contentMap['globalContourScale'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00033'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.globalContourScale'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.globalContourScale'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00033'
  currentMap['name'] = 'globalContourScale'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 100000.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00007')

  # Attribute AnalysisProjectV3.guid
  contentMap['guid'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:26_00002')

  # Attribute AnalysisProjectV3.isModifiable
  contentMap['isModifiable'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-17-14:16:26_00010__www.ccpn.ac.uk_Fogh_2007-10-03-14:53:27_00001__www.ccpn.ac.uk_Fogh_2006-09-14-16:28:57_00002')

  # Attribute AnalysisProjectV3.lastUnlockedBy
  contentMap['lastUnlockedBy'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:00:59_00003__www.ccpn.ac.uk_Fogh_2007-10-03-14:53:27_00001__www.ccpn.ac.uk_Fogh_2006-09-14-16:28:57_00002')

  # Attribute AnalysisProjectV3.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00030'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.name'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00030'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037')

  # Role AnalysisProjectV3.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role AnalysisProjectV3.analysisLayouts
  currentMap = {}
  contentMap['analysisLayouts'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00042'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.analysisLayouts'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.analysisLayouts'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00042'
  currentMap['name'] = 'analysisLayouts'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')

  # Role AnalysisProjectV3.analysisPanels
  currentMap = {}
  contentMap['analysisPanels'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00044'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.analysisPanels'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.analysisPanels'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:31_00044'
  currentMap['name'] = 'analysisPanels'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')

  # Role AnalysisProjectV3.analysisSpectra
  currentMap = {}
  contentMap['analysisSpectra'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00026'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.analysisSpectra'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.analysisSpectra'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00026'
  currentMap['name'] = 'analysisSpectra'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')

  # Role AnalysisProjectV3.annotationSettings
  currentMap = {}
  contentMap['annotationSettings'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00020'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.annotationSettings'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.annotationSettings'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00020'
  currentMap['name'] = 'annotationSettings'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')

  # Role AnalysisProjectV3.chainMappings
  currentMap = {}
  contentMap['chainMappings'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00002'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.chainMappings'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.chainMappings'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00002'
  currentMap['name'] = 'chainMappings'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')

  # Role AnalysisProjectV3.currentAnnotationSetting
  currentMap = {}
  contentMap['currentAnnotationSetting'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00027'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.currentAnnotationSetting'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.currentAnnotationSetting'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00027'
  currentMap['name'] = 'currentAnnotationSetting'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['implSkip'] = True
  currentMap['copyOverride'] = True

  # Role AnalysisProjectV3.currentPeakSetting
  currentMap = {}
  contentMap['currentPeakSetting'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00029'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.currentPeakSetting'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.currentPeakSetting'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00029'
  currentMap['name'] = 'currentPeakSetting'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['implSkip'] = True
  currentMap['copyOverride'] = True

  # Role AnalysisProjectV3.currentPrintSetting
  currentMap = {}
  contentMap['currentPrintSetting'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00028'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.currentPrintSetting'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.currentPrintSetting'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00028'
  currentMap['name'] = 'currentPrintSetting'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['implSkip'] = True
  currentMap['copyOverride'] = True

  # Role AnalysisProjectV3.nmrProject
  currentMap = {}
  contentMap['nmrProject'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00004'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.nmrProject'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.nmrProject'
  currentMap['type'] = 'exotop'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00004'
  currentMap['name'] = 'nmrProject'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = False
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisProjectV3.peakSettings
  currentMap = {}
  contentMap['peakSettings'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00022'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.peakSettings'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.peakSettings'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00022'
  currentMap['name'] = 'peakSettings'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')

  # Role AnalysisProjectV3.printSettings
  currentMap = {}
  contentMap['printSettings'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00024'] = currentMap
  loadMaps['ANA3.AnalysisProjectV3.printSettings'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisProjectV3.printSettings'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00024'
  currentMap['name'] = 'printSettings'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['implSkip'] = True
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')
  # End of AnalysisProjectV3

  currentMap = abstractTypes.get('AnalysisProjectV3')
  aList = ['autoBackupFreq', 'contourToUnaliased', 'createdBy', 'globalContourScale', 'guid', 'isModifiable', 'lastUnlockedBy', 'name']
  currentMap['headerAttrs'] = aList
  aList = ['details', 'currentAnnotationSetting', 'currentPeakSetting', 'currentPrintSetting']
  currentMap['simpleAttrs'] = aList
  aList = ['printSettings', 'peakSettings', 'chainMappings', 'annotationSettings', 'analysisSpectra', 'analysisPanels', 'analysisLayouts', 'nmrProject', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['analysisLayouts', 'analysisPanels', 'analysisSpectra', 'annotationSettings', 'chainMappings', 'peakSettings', 'printSettings']
  currentMap['children'] = aList

  # Class AnalysisSpectrum
  currentMap = {}
  abstractTypes['AnalysisSpectrum'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00006'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00006'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'analysisSpectra'
  currentMap['objkey'] = 'dataSource'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnalysisSpectrum
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute AnalysisSpectrum.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute AnalysisSpectrum.contourDir
  currentMap = {}
  contentMap['contourDir'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00049'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.contourDir'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.contourDir'
  currentMap['type'] = 'dobj'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00049'
  currentMap['name'] = 'contourDir'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('IMPL').get('abstractTypes')

  # Attribute AnalysisSpectrum.font
  currentMap = {}
  contentMap['font'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00050'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.font'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.font'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00050'
  currentMap['name'] = 'font'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute AnalysisSpectrum.negColors
  currentMap = {}
  contentMap['negColors'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00051'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.negColors'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.negColors'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00051'
  currentMap['name'] = 'negColors'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2011-12-02-09:49:50_00003')

  # Attribute AnalysisSpectrum.negLevelBase
  currentMap = {}
  contentMap['negLevelBase'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00041'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.negLevelBase'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.negLevelBase'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00041'
  currentMap['name'] = 'negLevelBase'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = -1.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00031')

  # Attribute AnalysisSpectrum.negLevelChanger
  currentMap = {}
  contentMap['negLevelChanger'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00042'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.negLevelChanger'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.negLevelChanger'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00042'
  currentMap['name'] = 'negLevelChanger'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1.5
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00031')

  # Attribute AnalysisSpectrum.negLevelMode
  currentMap = {}
  contentMap['negLevelMode'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00043'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.negLevelMode'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.negLevelMode'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00043'
  currentMap['name'] = 'negLevelMode'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 'multiply'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-05-05-17:24:12_00002')

  # Attribute AnalysisSpectrum.negLevelNum
  currentMap = {}
  contentMap['negLevelNum'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00044'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.negLevelNum'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.negLevelNum'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00044'
  currentMap['name'] = 'negLevelNum'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00001')

  # Attribute AnalysisSpectrum.pickThreshold
  currentMap = {}
  contentMap['pickThreshold'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00040'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.pickThreshold'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.pickThreshold'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00040'
  currentMap['name'] = 'pickThreshold'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00031')

  # Attribute AnalysisSpectrum.posColors
  currentMap = {}
  contentMap['posColors'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00001'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.posColors'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.posColors'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00001'
  currentMap['name'] = 'posColors'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2011-12-02-09:49:50_00003')

  # Attribute AnalysisSpectrum.posLevelBase
  currentMap = {}
  contentMap['posLevelBase'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00045'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.posLevelBase'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.posLevelBase'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00045'
  currentMap['name'] = 'posLevelBase'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00031')

  # Attribute AnalysisSpectrum.posLevelChanger
  currentMap = {}
  contentMap['posLevelChanger'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00046'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.posLevelChanger'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.posLevelChanger'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00046'
  currentMap['name'] = 'posLevelChanger'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1.5
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00031')

  # Attribute AnalysisSpectrum.posLevelMode
  currentMap = {}
  contentMap['posLevelMode'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00047'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.posLevelMode'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.posLevelMode'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00047'
  currentMap['name'] = 'posLevelMode'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 'multiply'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-05-05-17:24:12_00002')

  # Attribute AnalysisSpectrum.posLevelNum
  currentMap = {}
  contentMap['posLevelNum'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00048'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.posLevelNum'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.posLevelNum'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00048'
  currentMap['name'] = 'posLevelNum'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00001')

  # Attribute AnalysisSpectrum.rank
  currentMap = {}
  contentMap['rank'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00002'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.rank'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.rank'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00002'
  currentMap['name'] = 'rank'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00001')

  # Attribute AnalysisSpectrum.shortcut
  currentMap = {}
  contentMap['shortcut'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00003'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.shortcut'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.shortcut'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00003'
  currentMap['name'] = 'shortcut'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037')

  # Attribute AnalysisSpectrum.sliceColor
  currentMap = {}
  contentMap['sliceColor'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00004'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.sliceColor'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.sliceColor'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00004'
  currentMap['name'] = 'sliceColor'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['default'] = '#808080FF'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2011-12-02-09:49:50_00003')

  # Attribute AnalysisSpectrum.useBoundingBox
  currentMap = {}
  contentMap['useBoundingBox'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00005'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.useBoundingBox'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.useBoundingBox'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00005'
  currentMap['name'] = 'useBoundingBox'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute AnalysisSpectrum.useCompression
  currentMap = {}
  contentMap['useCompression'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00008'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.useCompression'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.useCompression'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00008'
  currentMap['name'] = 'useCompression'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute AnalysisSpectrum.usePeakArrow
  currentMap = {}
  contentMap['usePeakArrow'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00006'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.usePeakArrow'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.usePeakArrow'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00006'
  currentMap['name'] = 'usePeakArrow'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute AnalysisSpectrum.usePrecalculated
  currentMap = {}
  contentMap['usePrecalculated'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00007'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.usePrecalculated'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.usePrecalculated'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00007'
  currentMap['name'] = 'usePrecalculated'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Role AnalysisSpectrum.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role AnalysisSpectrum.analysisDataDims
  currentMap = {}
  contentMap['analysisDataDims'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00035'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.analysisDataDims'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.analysisDataDims'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00035'
  currentMap['name'] = 'analysisDataDims'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')

  # Role AnalysisSpectrum.analysisPeakLists
  currentMap = {}
  contentMap['analysisPeakLists'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00037'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.analysisPeakLists'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.analysisPeakLists'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00037'
  currentMap['name'] = 'analysisPeakLists'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')

  # Role AnalysisSpectrum.dataSource
  currentMap = {}
  contentMap['dataSource'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-11:04:36_00001'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.dataSource'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.dataSource'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-11:04:36_00001'
  currentMap['name'] = 'dataSource'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('NMR').get('exolinks')

  # Role AnalysisSpectrum.spectrumMappings
  currentMap = {}
  contentMap['spectrumMappings'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00049'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.spectrumMappings'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.spectrumMappings'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00049'
  currentMap['name'] = 'spectrumMappings'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')

  # Role AnalysisSpectrum.storedContours
  currentMap = {}
  contentMap['storedContours'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00039'] = currentMap
  loadMaps['ANA3.AnalysisSpectrum.storedContours'] = currentMap
  currentMap['tag'] = 'ANA3.AnalysisSpectrum.storedContours'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00039'
  currentMap['name'] = 'storedContours'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')
  # End of AnalysisSpectrum

  currentMap = abstractTypes.get('AnalysisSpectrum')
  aList = ['negLevelBase', 'negLevelChanger', 'negLevelMode', 'negLevelNum', 'pickThreshold', 'posLevelBase', 'posLevelChanger', 'posLevelMode', 'posLevelNum', 'rank', 'shortcut', 'useBoundingBox', 'useCompression', 'usePeakArrow', 'usePrecalculated']
  currentMap['headerAttrs'] = aList
  aList = ['font', 'negColors', 'posColors', 'sliceColor']
  currentMap['simpleAttrs'] = aList
  aList = ['storedContours', 'spectrumMappings', 'analysisPeakLists', 'analysisDataDims', 'dataSource', 'access', 'contourDir', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['analysisDataDims', 'analysisPeakLists', 'spectrumMappings', 'storedContours']
  currentMap['children'] = aList

  # Class AnnotationSetting
  currentMap = {}
  abstractTypes['AnnotationSetting'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00003'] = currentMap
  loadMaps['ANA3.AnnotationSetting'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00003'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'annotationSettings'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnnotationSetting
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute AnnotationSetting.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute AnnotationSetting.meritBad
  currentMap = {}
  contentMap['meritBad'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00007'] = currentMap
  loadMaps['ANA3.AnnotationSetting.meritBad'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.meritBad'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00007'
  currentMap['name'] = 'meritBad'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037')

  # Attribute AnnotationSetting.meritGood
  currentMap = {}
  contentMap['meritGood'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00008'] = currentMap
  loadMaps['ANA3.AnnotationSetting.meritGood'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.meritGood'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00008'
  currentMap['name'] = 'meritGood'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037')

  # Attribute AnnotationSetting.meritMediocre
  currentMap = {}
  contentMap['meritMediocre'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00009'] = currentMap
  loadMaps['ANA3.AnnotationSetting.meritMediocre'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.meritMediocre'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00009'
  currentMap['name'] = 'meritMediocre'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037')

  # Attribute AnnotationSetting.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00010'] = currentMap
  loadMaps['ANA3.AnnotationSetting.name'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00010'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute AnnotationSetting.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00009'] = currentMap
  loadMaps['ANA3.AnnotationSetting.serial'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00009'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute AnnotationSetting.useAtom
  currentMap = {}
  contentMap['useAtom'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00004'] = currentMap
  loadMaps['ANA3.AnnotationSetting.useAtom'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.useAtom'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00004'
  currentMap['name'] = 'useAtom'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute AnnotationSetting.useChain
  currentMap = {}
  contentMap['useChain'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00002'] = currentMap
  loadMaps['ANA3.AnnotationSetting.useChain'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.useChain'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00002'
  currentMap['name'] = 'useChain'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute AnnotationSetting.useDetail
  currentMap = {}
  contentMap['useDetail'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00005'] = currentMap
  loadMaps['ANA3.AnnotationSetting.useDetail'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.useDetail'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00005'
  currentMap['name'] = 'useDetail'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute AnnotationSetting.useMerit
  currentMap = {}
  contentMap['useMerit'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00006'] = currentMap
  loadMaps['ANA3.AnnotationSetting.useMerit'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.useMerit'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00006'
  currentMap['name'] = 'useMerit'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute AnnotationSetting.useMolSys
  currentMap = {}
  contentMap['useMolSys'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00001'] = currentMap
  loadMaps['ANA3.AnnotationSetting.useMolSys'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.useMolSys'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00001'
  currentMap['name'] = 'useMolSys'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute AnnotationSetting.useNumbersFirst
  currentMap = {}
  contentMap['useNumbersFirst'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00011'] = currentMap
  loadMaps['ANA3.AnnotationSetting.useNumbersFirst'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.useNumbersFirst'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00011'
  currentMap['name'] = 'useNumbersFirst'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute AnnotationSetting.useOneLetterCodes
  currentMap = {}
  contentMap['useOneLetterCodes'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00012'] = currentMap
  loadMaps['ANA3.AnnotationSetting.useOneLetterCodes'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.useOneLetterCodes'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:01_00012'
  currentMap['name'] = 'useOneLetterCodes'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute AnnotationSetting.useResidue
  currentMap = {}
  contentMap['useResidue'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00003'] = currentMap
  loadMaps['ANA3.AnnotationSetting.useResidue'] = currentMap
  currentMap['tag'] = 'ANA3.AnnotationSetting.useResidue'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00003'
  currentMap['name'] = 'useResidue'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Role AnnotationSetting.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')
  # End of AnnotationSetting

  currentMap = abstractTypes.get('AnnotationSetting')
  aList = ['meritBad', 'meritGood', 'meritMediocre', 'serial', 'useAtom', 'useChain', 'useDetail', 'useMerit', 'useMolSys', 'useNumbersFirst', 'useOneLetterCodes', 'useResidue']
  currentMap['headerAttrs'] = aList
  aList = ['name']
  currentMap['simpleAttrs'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class AtomSetMapping
  currentMap = {}
  abstractTypes['AtomSetMapping'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:56_00003'] = currentMap
  loadMaps['ANA3.AtomSetMapping'] = currentMap
  currentMap['tag'] = 'ANA3.AtomSetMapping'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:56_00003'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'atomSetMappings'
  currentMap['objkey'] = 'name'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AtomSetMapping
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute AtomSetMapping.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute AtomSetMapping.atomSetSerials
  currentMap = {}
  contentMap['atomSetSerials'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00011'] = currentMap
  loadMaps['ANA3.AtomSetMapping.atomSetSerials'] = currentMap
  currentMap['tag'] = 'ANA3.AtomSetMapping.atomSetSerials'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00011'
  currentMap['name'] = 'atomSetSerials'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute AtomSetMapping.elementSymbol
  currentMap = {}
  contentMap['elementSymbol'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00014'] = currentMap
  loadMaps['ANA3.AtomSetMapping.elementSymbol'] = currentMap
  currentMap['tag'] = 'ANA3.AtomSetMapping.elementSymbol'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00014'
  currentMap['name'] = 'elementSymbol'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037')

  # Attribute AtomSetMapping.mappingType
  currentMap = {}
  contentMap['mappingType'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00013'] = currentMap
  loadMaps['ANA3.AtomSetMapping.mappingType'] = currentMap
  currentMap['tag'] = 'ANA3.AtomSetMapping.mappingType'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00013'
  currentMap['name'] = 'mappingType'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 'simple'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-17-14:16:22_00018')

  # Attribute AtomSetMapping.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00010'] = currentMap
  loadMaps['ANA3.AtomSetMapping.name'] = currentMap
  currentMap['tag'] = 'ANA3.AtomSetMapping.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00010'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037')

  # Attribute AtomSetMapping.resonanceSerials
  currentMap = {}
  contentMap['resonanceSerials'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00012'] = currentMap
  loadMaps['ANA3.AtomSetMapping.resonanceSerials'] = currentMap
  currentMap['tag'] = 'ANA3.AtomSetMapping.resonanceSerials'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00012'
  currentMap['name'] = 'resonanceSerials'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Role AtomSetMapping.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role AtomSetMapping.atomSetMappings
  currentMap = {}
  contentMap['atomSetMappings'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00008'] = currentMap
  loadMaps['ANA3.AtomSetMapping.atomSetMappings'] = currentMap
  currentMap['tag'] = 'ANA3.AtomSetMapping.atomSetMappings'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00008'
  currentMap['name'] = 'atomSetMappings'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['copyOverride'] = True

  # Role AtomSetMapping.chemAtomSet
  currentMap = {}
  contentMap['chemAtomSet'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00005'] = currentMap
  loadMaps['ANA3.AtomSetMapping.chemAtomSet'] = currentMap
  currentMap['tag'] = 'ANA3.AtomSetMapping.chemAtomSet'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00005'
  currentMap['name'] = 'chemAtomSet'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('CHEM').get('exolinks')
  # End of AtomSetMapping

  currentMap = abstractTypes.get('AtomSetMapping')
  aList = ['elementSymbol', 'mappingType', 'name']
  currentMap['headerAttrs'] = aList
  aList = ['atomSetSerials', 'resonanceSerials', 'atomSetMappings']
  currentMap['simpleAttrs'] = aList
  aList = ['chemAtomSet', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class AxisMapping
  currentMap = {}
  abstractTypes['AxisMapping'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00009'] = currentMap
  loadMaps['ANA3.AxisMapping'] = currentMap
  currentMap['tag'] = 'ANA3.AxisMapping'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00009'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'axisMappings'
  currentMap['objkey'] = 'windowAxis'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AxisMapping
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute AxisMapping.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Role AxisMapping.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role AxisMapping.analysisDataDim
  currentMap = {}
  contentMap['analysisDataDim'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00003'] = currentMap
  loadMaps['ANA3.AxisMapping.analysisDataDim'] = currentMap
  currentMap['tag'] = 'ANA3.AxisMapping.analysisDataDim'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00003'
  currentMap['name'] = 'analysisDataDim'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['copyOverride'] = True

  # Role AxisMapping.windowAxis
  currentMap = {}
  contentMap['windowAxis'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00011'] = currentMap
  loadMaps['ANA3.AxisMapping.windowAxis'] = currentMap
  currentMap['tag'] = 'ANA3.AxisMapping.windowAxis'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00011'
  currentMap['name'] = 'windowAxis'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('ANAW').get('exolinks')
  # End of AxisMapping

  currentMap = abstractTypes.get('AxisMapping')
  aList = ['analysisDataDim']
  currentMap['optLinks'] = aList
  aList = ['windowAxis', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class ChainMapping
  currentMap = {}
  abstractTypes['ChainMapping'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:56_00001'] = currentMap
  loadMaps['ANA3.ChainMapping'] = currentMap
  currentMap['tag'] = 'ANA3.ChainMapping'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:56_00001'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'chainMappings'
  currentMap['class'] = ccpnmr.api.AnalysisV3.ChainMapping
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute ChainMapping.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute ChainMapping.chainCode
  currentMap = {}
  contentMap['chainCode'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00021'] = currentMap
  loadMaps['ANA3.ChainMapping.chainCode'] = currentMap
  currentMap['tag'] = 'ANA3.ChainMapping.chainCode'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00021'
  currentMap['name'] = 'chainCode'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute ChainMapping.molSystemCode
  currentMap = {}
  contentMap['molSystemCode'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00020'] = currentMap
  loadMaps['ANA3.ChainMapping.molSystemCode'] = currentMap
  currentMap['tag'] = 'ANA3.ChainMapping.molSystemCode'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00020'
  currentMap['name'] = 'molSystemCode'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037')

  # Role ChainMapping.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role ChainMapping.residueMappings
  currentMap = {}
  contentMap['residueMappings'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00018'] = currentMap
  loadMaps['ANA3.ChainMapping.residueMappings'] = currentMap
  currentMap['tag'] = 'ANA3.ChainMapping.residueMappings'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00018'
  currentMap['name'] = 'residueMappings'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')
  # End of ChainMapping

  currentMap = abstractTypes.get('ChainMapping')
  aList = ['molSystemCode']
  currentMap['headerAttrs'] = aList
  aList = ['chainCode']
  currentMap['simpleAttrs'] = aList
  aList = ['residueMappings', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['residueMappings']
  currentMap['children'] = aList

  # Class PeakListView
  currentMap = {}
  abstractTypes['PeakListView'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00025'] = currentMap
  loadMaps['ANA3.PeakListView'] = currentMap
  currentMap['tag'] = 'ANA3.PeakListView'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00025'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'peakListViews'
  currentMap['objkey'] = 'analysisPeakList'
  currentMap['class'] = ccpnmr.api.AnalysisV3.PeakListView
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute PeakListView.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute PeakListView.isAnnotationDrawn
  currentMap = {}
  contentMap['isAnnotationDrawn'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00012'] = currentMap
  loadMaps['ANA3.PeakListView.isAnnotationDrawn'] = currentMap
  currentMap['tag'] = 'ANA3.PeakListView.isAnnotationDrawn'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00012'
  currentMap['name'] = 'isAnnotationDrawn'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PeakListView.isSymbolDrawn
  currentMap = {}
  contentMap['isSymbolDrawn'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00013'] = currentMap
  loadMaps['ANA3.PeakListView.isSymbolDrawn'] = currentMap
  currentMap['tag'] = 'ANA3.PeakListView.isSymbolDrawn'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00013'
  currentMap['name'] = 'isSymbolDrawn'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Role PeakListView.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role PeakListView.analysisPeakList
  currentMap = {}
  contentMap['analysisPeakList'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00011'] = currentMap
  loadMaps['ANA3.PeakListView.analysisPeakList'] = currentMap
  currentMap['tag'] = 'ANA3.PeakListView.analysisPeakList'
  currentMap['type'] = 'link'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:53:58_00011'
  currentMap['name'] = 'analysisPeakList'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['copyOverride'] = True
  # End of PeakListView

  currentMap = abstractTypes.get('PeakListView')
  aList = ['isAnnotationDrawn', 'isSymbolDrawn']
  currentMap['headerAttrs'] = aList
  aList = ['analysisPeakList']
  currentMap['optLinks'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class PeakSetting
  currentMap = {}
  abstractTypes['PeakSetting'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00004'] = currentMap
  loadMaps['ANA3.PeakSetting'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00004'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'peakSettings'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccpnmr.api.AnalysisV3.PeakSetting
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute PeakSetting.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute PeakSetting.drawMethod
  currentMap = {}
  contentMap['drawMethod'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00016'] = currentMap
  loadMaps['ANA3.PeakSetting.drawMethod'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.drawMethod'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00016'
  currentMap['name'] = 'drawMethod'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-10-03-11:26:03_00002')

  # Attribute PeakSetting.intensityScale
  currentMap = {}
  contentMap['intensityScale'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00025'] = currentMap
  loadMaps['ANA3.PeakSetting.intensityScale'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.intensityScale'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00025'
  currentMap['name'] = 'intensityScale'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1000000.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00007')

  # Attribute PeakSetting.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00015'] = currentMap
  loadMaps['ANA3.PeakSetting.name'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00015'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute PeakSetting.pickBuffer
  currentMap = {}
  contentMap['pickBuffer'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00018'] = currentMap
  loadMaps['ANA3.PeakSetting.pickBuffer'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.pickBuffer'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00018'
  currentMap['name'] = 'pickBuffer'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00011')

  # Attribute PeakSetting.pickDrop
  currentMap = {}
  contentMap['pickDrop'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00019'] = currentMap
  loadMaps['ANA3.PeakSetting.pickDrop'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.pickDrop'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00019'
  currentMap['name'] = 'pickDrop'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 0.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00058')

  # Attribute PeakSetting.pickMax
  currentMap = {}
  contentMap['pickMax'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00020'] = currentMap
  loadMaps['ANA3.PeakSetting.pickMax'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.pickMax'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00020'
  currentMap['name'] = 'pickMax'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PeakSetting.pickMin
  currentMap = {}
  contentMap['pickMin'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00021'] = currentMap
  loadMaps['ANA3.PeakSetting.pickMin'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.pickMin'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00021'
  currentMap['name'] = 'pickMin'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PeakSetting.pickNonadjacent
  currentMap = {}
  contentMap['pickNonadjacent'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00022'] = currentMap
  loadMaps['ANA3.PeakSetting.pickNonadjacent'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.pickNonadjacent'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00022'
  currentMap['name'] = 'pickNonadjacent'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PeakSetting.pickScale
  currentMap = {}
  contentMap['pickScale'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00023'] = currentMap
  loadMaps['ANA3.PeakSetting.pickScale'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.pickScale'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00023'
  currentMap['name'] = 'pickScale'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00007')

  # Attribute PeakSetting.pickThickness
  currentMap = {}
  contentMap['pickThickness'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00024'] = currentMap
  loadMaps['ANA3.PeakSetting.pickThickness'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.pickThickness'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00024'
  currentMap['name'] = 'pickThickness'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00011')

  # Attribute PeakSetting.pickVolumeMethod
  currentMap = {}
  contentMap['pickVolumeMethod'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00017'] = currentMap
  loadMaps['ANA3.PeakSetting.pickVolumeMethod'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.pickVolumeMethod'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00017'
  currentMap['name'] = 'pickVolumeMethod'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-10-03-11:26:03_00003')

  # Attribute PeakSetting.pixelSize
  currentMap = {}
  contentMap['pixelSize'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00027'] = currentMap
  loadMaps['ANA3.PeakSetting.pixelSize'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.pixelSize'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00027'
  currentMap['name'] = 'pixelSize'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 10
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00001')

  # Attribute PeakSetting.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00014'] = currentMap
  loadMaps['ANA3.PeakSetting.serial'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00014'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute PeakSetting.volumeScale
  currentMap = {}
  contentMap['volumeScale'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00026'] = currentMap
  loadMaps['ANA3.PeakSetting.volumeScale'] = currentMap
  currentMap['tag'] = 'ANA3.PeakSetting.volumeScale'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00026'
  currentMap['name'] = 'volumeScale'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1000000.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00007')

  # Role PeakSetting.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')
  # End of PeakSetting

  currentMap = abstractTypes.get('PeakSetting')
  aList = ['intensityScale', 'pickBuffer', 'pickDrop', 'pickMax', 'pickMin', 'pickNonadjacent', 'pickScale', 'pickThickness', 'pixelSize', 'serial', 'volumeScale']
  currentMap['headerAttrs'] = aList
  aList = ['drawMethod', 'name', 'pickVolumeMethod']
  currentMap['simpleAttrs'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class PrintSetting
  currentMap = {}
  abstractTypes['PrintSetting'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00005'] = currentMap
  loadMaps['ANA3.PrintSetting'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00005'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'printSettings'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccpnmr.api.AnalysisV3.PrintSetting
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute PrintSetting.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute PrintSetting.fileName
  currentMap = {}
  contentMap['fileName'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00031'] = currentMap
  loadMaps['ANA3.PrintSetting.fileName'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.fileName'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00031'
  currentMap['name'] = 'fileName'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00003')

  # Attribute PrintSetting.font
  currentMap = {}
  contentMap['font'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00030'] = currentMap
  loadMaps['ANA3.PrintSetting.font'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.font'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00030'
  currentMap['name'] = 'font'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute PrintSetting.inColor
  currentMap = {}
  contentMap['inColor'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00032'] = currentMap
  loadMaps['ANA3.PrintSetting.inColor'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.inColor'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00032'
  currentMap['name'] = 'inColor'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PrintSetting.name
  currentMap = {}
  contentMap['name'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00029'] = currentMap
  loadMaps['ANA3.PrintSetting.name'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.name'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00029'
  currentMap['name'] = 'name'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Attribute PrintSetting.orientation
  currentMap = {}
  contentMap['orientation'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00033'] = currentMap
  loadMaps['ANA3.PrintSetting.orientation'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.orientation'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00033'
  currentMap['name'] = 'orientation'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['default'] = 'Portrait'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-05-05-15:12:50_00013')

  # Attribute PrintSetting.otherHeight
  currentMap = {}
  contentMap['otherHeight'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00034'] = currentMap
  loadMaps['ANA3.PrintSetting.otherHeight'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.otherHeight'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00034'
  currentMap['name'] = 'otherHeight'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00007')

  # Attribute PrintSetting.otherUnit
  currentMap = {}
  contentMap['otherUnit'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00036'] = currentMap
  loadMaps['ANA3.PrintSetting.otherUnit'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.otherUnit'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00036'
  currentMap['name'] = 'otherUnit'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['default'] = 'cm'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-05-05-15:12:50_00011')

  # Attribute PrintSetting.otherWidth
  currentMap = {}
  contentMap['otherWidth'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00035'] = currentMap
  loadMaps['ANA3.PrintSetting.otherWidth'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.otherWidth'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00035'
  currentMap['name'] = 'otherWidth'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00007')

  # Attribute PrintSetting.outputFormat
  currentMap = {}
  contentMap['outputFormat'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00037'] = currentMap
  loadMaps['ANA3.PrintSetting.outputFormat'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.outputFormat'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00037'
  currentMap['name'] = 'outputFormat'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['default'] = 'PS'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-05-05-15:12:50_00012')

  # Attribute PrintSetting.paperSize
  currentMap = {}
  contentMap['paperSize'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00038'] = currentMap
  loadMaps['ANA3.PrintSetting.paperSize'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.paperSize'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00038'
  currentMap['name'] = 'paperSize'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['proc'] = 'direct'
  currentMap['default'] = 'A4'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-05-05-15:12:50_00010')

  # Attribute PrintSetting.scaling
  currentMap = {}
  contentMap['scaling'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00039'] = currentMap
  loadMaps['ANA3.PrintSetting.scaling'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.scaling'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00039'
  currentMap['name'] = 'scaling'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 0.7
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00007')

  # Attribute PrintSetting.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00028'] = currentMap
  loadMaps['ANA3.PrintSetting.serial'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00028'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Attribute PrintSetting.showFileName
  currentMap = {}
  contentMap['showFileName'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00041'] = currentMap
  loadMaps['ANA3.PrintSetting.showFileName'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.showFileName'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00041'
  currentMap['name'] = 'showFileName'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PrintSetting.showsDateTime
  currentMap = {}
  contentMap['showsDateTime'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00040'] = currentMap
  loadMaps['ANA3.PrintSetting.showsDateTime'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.showsDateTime'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00040'
  currentMap['name'] = 'showsDateTime'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PrintSetting.tickBottom
  currentMap = {}
  contentMap['tickBottom'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00045'] = currentMap
  loadMaps['ANA3.PrintSetting.tickBottom'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.tickBottom'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00045'
  currentMap['name'] = 'tickBottom'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PrintSetting.tickInside
  currentMap = {}
  contentMap['tickInside'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00043'] = currentMap
  loadMaps['ANA3.PrintSetting.tickInside'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.tickInside'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00043'
  currentMap['name'] = 'tickInside'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PrintSetting.tickLeft
  currentMap = {}
  contentMap['tickLeft'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00046'] = currentMap
  loadMaps['ANA3.PrintSetting.tickLeft'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.tickLeft'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00046'
  currentMap['name'] = 'tickLeft'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PrintSetting.tickOurside
  currentMap = {}
  contentMap['tickOurside'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00042'] = currentMap
  loadMaps['ANA3.PrintSetting.tickOurside'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.tickOurside'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00042'
  currentMap['name'] = 'tickOurside'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PrintSetting.tickRight
  currentMap = {}
  contentMap['tickRight'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00047'] = currentMap
  loadMaps['ANA3.PrintSetting.tickRight'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.tickRight'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00047'
  currentMap['name'] = 'tickRight'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PrintSetting.tickTop
  currentMap = {}
  contentMap['tickTop'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00044'] = currentMap
  loadMaps['ANA3.PrintSetting.tickTop'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.tickTop'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00044'
  currentMap['name'] = 'tickTop'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute PrintSetting.title
  currentMap = {}
  contentMap['title'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00048'] = currentMap
  loadMaps['ANA3.PrintSetting.title'] = currentMap
  currentMap['tag'] = 'ANA3.PrintSetting.title'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:31_00048'
  currentMap['name'] = 'title'
  currentMap['hicard'] = 1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033')

  # Role PrintSetting.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')
  # End of PrintSetting

  currentMap = abstractTypes.get('PrintSetting')
  aList = ['inColor', 'otherHeight', 'otherWidth', 'scaling', 'serial', 'showFileName', 'showsDateTime', 'tickBottom', 'tickInside', 'tickLeft', 'tickOurside', 'tickRight', 'tickTop']
  currentMap['headerAttrs'] = aList
  aList = ['fileName', 'font', 'name', 'orientation', 'otherUnit', 'outputFormat', 'paperSize', 'title']
  currentMap['simpleAttrs'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Class ResidueMapping
  currentMap = {}
  abstractTypes['ResidueMapping'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:56_00002'] = currentMap
  loadMaps['ANA3.ResidueMapping'] = currentMap
  currentMap['tag'] = 'ANA3.ResidueMapping'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:56_00002'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'residueMappings'
  currentMap['objkey'] = 'seqId'
  currentMap['class'] = ccpnmr.api.AnalysisV3.ResidueMapping
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute ResidueMapping.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute ResidueMapping.seqId
  currentMap = {}
  contentMap['seqId'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00026'] = currentMap
  loadMaps['ANA3.ResidueMapping.seqId'] = currentMap
  currentMap['tag'] = 'ANA3.ResidueMapping.seqId'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00026'
  currentMap['name'] = 'seqId'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['proc'] = 'direct'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Role ResidueMapping.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role ResidueMapping.atomSetMappings
  currentMap = {}
  contentMap['atomSetMappings'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00024'] = currentMap
  loadMaps['ANA3.ResidueMapping.atomSetMappings'] = currentMap
  currentMap['tag'] = 'ANA3.ResidueMapping.atomSetMappings'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:59_00024'
  currentMap['name'] = 'atomSetMappings'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')
  # End of ResidueMapping

  currentMap = abstractTypes.get('ResidueMapping')
  aList = ['seqId']
  currentMap['headerAttrs'] = aList
  aList = ['atomSetMappings', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['atomSetMappings']
  currentMap['children'] = aList

  # Class SpectrumMapping
  currentMap = {}
  abstractTypes['SpectrumMapping'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00008'] = currentMap
  loadMaps['ANA3.SpectrumMapping'] = currentMap
  currentMap['tag'] = 'ANA3.SpectrumMapping'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00008'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'spectrumMappings'
  currentMap['objkey'] = 'window'
  currentMap['class'] = ccpnmr.api.AnalysisV3.SpectrumMapping
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute SpectrumMapping.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute SpectrumMapping.isInToolbar
  currentMap = {}
  contentMap['isInToolbar'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00006'] = currentMap
  loadMaps['ANA3.SpectrumMapping.isInToolbar'] = currentMap
  currentMap['tag'] = 'ANA3.SpectrumMapping.isInToolbar'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00006'
  currentMap['name'] = 'isInToolbar'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Role SpectrumMapping.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role SpectrumMapping.axisMappings
  currentMap = {}
  contentMap['axisMappings'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00003'] = currentMap
  loadMaps['ANA3.SpectrumMapping.axisMappings'] = currentMap
  currentMap['tag'] = 'ANA3.SpectrumMapping.axisMappings'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00003'
  currentMap['name'] = 'axisMappings'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')

  # Role SpectrumMapping.spectrumViews
  currentMap = {}
  contentMap['spectrumViews'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00005'] = currentMap
  loadMaps['ANA3.SpectrumMapping.spectrumViews'] = currentMap
  currentMap['tag'] = 'ANA3.SpectrumMapping.spectrumViews'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00005'
  currentMap['name'] = 'spectrumViews'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')

  # Role SpectrumMapping.window
  currentMap = {}
  contentMap['window'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-11:01:45_00011'] = currentMap
  loadMaps['ANA3.SpectrumMapping.window'] = currentMap
  currentMap['tag'] = 'ANA3.SpectrumMapping.window'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-11:01:45_00011'
  currentMap['name'] = 'window'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('ANAW').get('exolinks')
  # End of SpectrumMapping

  currentMap = abstractTypes.get('SpectrumMapping')
  aList = ['isInToolbar']
  currentMap['headerAttrs'] = aList
  aList = ['spectrumViews', 'axisMappings', 'window', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['axisMappings', 'spectrumViews']
  currentMap['children'] = aList

  # Class SpectrumView
  currentMap = {}
  abstractTypes['SpectrumView'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00024'] = currentMap
  loadMaps['ANA3.SpectrumView'] = currentMap
  currentMap['tag'] = 'ANA3.SpectrumView'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00024'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'spectrumViews'
  currentMap['objkey'] = 'windowPanel'
  currentMap['class'] = ccpnmr.api.AnalysisV3.SpectrumView
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute SpectrumView.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute SpectrumView.intensityScaling
  currentMap = {}
  contentMap['intensityScaling'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-21-18:09:11_00001'] = currentMap
  loadMaps['ANA3.SpectrumView.intensityScaling'] = currentMap
  currentMap['tag'] = 'ANA3.SpectrumView.intensityScaling'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-21-18:09:11_00001'
  currentMap['name'] = 'intensityScaling'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = 1.0
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00031')

  # Attribute SpectrumView.isInToolbar
  currentMap = {}
  contentMap['isInToolbar'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2012-05-14-13:21:11_00001'] = currentMap
  loadMaps['ANA3.SpectrumView.isInToolbar'] = currentMap
  currentMap['tag'] = 'ANA3.SpectrumView.isInToolbar'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2012-05-14-13:21:11_00001'
  currentMap['name'] = 'isInToolbar'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute SpectrumView.isNegVisible
  currentMap = {}
  contentMap['isNegVisible'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00009'] = currentMap
  loadMaps['ANA3.SpectrumView.isNegVisible'] = currentMap
  currentMap['tag'] = 'ANA3.SpectrumView.isNegVisible'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00009'
  currentMap['name'] = 'isNegVisible'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = False
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Attribute SpectrumView.isPosVisible
  currentMap = {}
  contentMap['isPosVisible'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00010'] = currentMap
  loadMaps['ANA3.SpectrumView.isPosVisible'] = currentMap
  currentMap['tag'] = 'ANA3.SpectrumView.isPosVisible'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00010'
  currentMap['name'] = 'isPosVisible'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['default'] = True
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00028')

  # Role SpectrumView.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')

  # Role SpectrumView.peakListViews
  currentMap = {}
  contentMap['peakListViews'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00008'] = currentMap
  loadMaps['ANA3.SpectrumView.peakListViews'] = currentMap
  currentMap['tag'] = 'ANA3.SpectrumView.peakListViews'
  currentMap['type'] = 'child'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00008'
  currentMap['name'] = 'peakListViews'
  currentMap['hicard'] = -1
  currentMap['locard'] = 0
  currentMap['eType'] = 'cplx'
  currentMap['content'] = globalMap.get('ANA3').get('abstractTypes')

  # Role SpectrumView.windowPanel
  currentMap = {}
  contentMap['windowPanel'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-11:03:44_00010'] = currentMap
  loadMaps['ANA3.SpectrumView.windowPanel'] = currentMap
  currentMap['tag'] = 'ANA3.SpectrumView.windowPanel'
  currentMap['type'] = 'exolink'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-11:03:44_00010'
  currentMap['name'] = 'windowPanel'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['copyOverride'] = True
  currentMap['content'] = globalMap.get('ANAY').get('exolinks')
  # End of SpectrumView

  currentMap = abstractTypes.get('SpectrumView')
  aList = ['intensityScaling', 'isInToolbar', 'isNegVisible', 'isPosVisible']
  currentMap['headerAttrs'] = aList
  aList = ['peakListViews', 'windowPanel', 'access', 'applicationData']
  currentMap['cplxAttrs'] = aList
  aList = ['peakListViews']
  currentMap['children'] = aList

  # Class StoredContour
  currentMap = {}
  abstractTypes['StoredContour'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00003'] = currentMap
  loadMaps['ANA3.StoredContour'] = currentMap
  currentMap['tag'] = 'ANA3.StoredContour'
  currentMap['type'] = 'class'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00003'
  currentMap['eType'] = 'cplx'
  currentMap['fromParent'] = 'storedContours'
  currentMap['objkey'] = 'serial'
  currentMap['class'] = ccpnmr.api.AnalysisV3.StoredContour
  contentMap = {}
  currentMap['content'] = contentMap

  # Attribute StoredContour.applicationData
  contentMap['applicationData'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-09-14-18:48:27_00007')

  # Attribute StoredContour.dims
  currentMap = {}
  contentMap['dims'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00013'] = currentMap
  loadMaps['ANA3.StoredContour.dims'] = currentMap
  currentMap['tag'] = 'ANA3.StoredContour.dims'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00013'
  currentMap['name'] = 'dims'
  currentMap['hicard'] = 2
  currentMap['locard'] = 2
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00001')

  # Attribute StoredContour.path
  currentMap = {}
  contentMap['path'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-11:00:37_00001'] = currentMap
  loadMaps['ANA3.StoredContour.path'] = currentMap
  currentMap['tag'] = 'ANA3.StoredContour.path'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-11:00:37_00001'
  currentMap['name'] = 'path'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['eType'] = 'cplx'
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:54_00003')

  # Attribute StoredContour.serial
  currentMap = {}
  contentMap['serial'] = currentMap
  mapsByGuid['www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00012'] = currentMap
  loadMaps['ANA3.StoredContour.serial'] = currentMap
  currentMap['tag'] = 'ANA3.StoredContour.serial'
  currentMap['type'] = 'attr'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-30-10:55:32_00012'
  currentMap['name'] = 'serial'
  currentMap['hicard'] = 1
  currentMap['locard'] = 1
  currentMap['data'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032')

  # Role StoredContour.access
  contentMap['access'] = mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-12-31-09:03:01_00014')
  # End of StoredContour

  currentMap = abstractTypes.get('StoredContour')
  aList = ['serial']
  currentMap['headerAttrs'] = aList
  aList = ['dims', 'path']
  currentMap['simpleAttrs'] = aList
  aList = ['access', 'applicationData']
  currentMap['cplxAttrs'] = aList

  # Out-of-package link to AnalysisDataDim
  currentMap = {}
  exolinks['AnalysisDataDim'] = currentMap
  loadMaps['ANA3.exo-AnalysisDataDim'] = currentMap
  currentMap['tag'] = 'ANA3.exo-AnalysisDataDim'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00001'
  currentMap['name'] = 'AnalysisDataDim'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnalysisDataDim
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(globalMap.get('NMR').get('exolinks'))
  aList.append(globalMap.get('NMR').get('exolinks'))

  # Out-of-package link to AnalysisLayout
  currentMap = {}
  exolinks['AnalysisLayout'] = currentMap
  loadMaps['ANA3.exo-AnalysisLayout'] = currentMap
  currentMap['tag'] = 'ANA3.exo-AnalysisLayout'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:29_00001'
  currentMap['name'] = 'AnalysisLayout'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnalysisLayout
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(globalMap.get('ANAY').get('exolinks'))

  # Out-of-package link to AnalysisPanel
  currentMap = {}
  exolinks['AnalysisPanel'] = currentMap
  loadMaps['ANA3.exo-AnalysisPanel'] = currentMap
  currentMap['tag'] = 'ANA3.exo-AnalysisPanel'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-02-15:08:29_00002'
  currentMap['name'] = 'AnalysisPanel'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnalysisPanel
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(globalMap.get('ANAY').get('exolinks'))

  # Out-of-package link to AnalysisPeakList
  currentMap = {}
  exolinks['AnalysisPeakList'] = currentMap
  loadMaps['ANA3.exo-AnalysisPeakList'] = currentMap
  currentMap['tag'] = 'ANA3.exo-AnalysisPeakList'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00002'
  currentMap['name'] = 'AnalysisPeakList'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnalysisPeakList
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(globalMap.get('NMR').get('exolinks'))
  aList.append(globalMap.get('NMR').get('exolinks'))

  # Out-of-package link to AnalysisProjectV3
  currentMap = {}
  exolinks['AnalysisProjectV3'] = currentMap
  loadMaps['ANA3.exo-AnalysisProjectV3'] = currentMap
  currentMap['tag'] = 'ANA3.exo-AnalysisProjectV3'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00002'
  currentMap['name'] = 'AnalysisProjectV3'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnalysisProjectV3
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))

  # Out-of-package link to AnalysisSpectrum
  currentMap = {}
  exolinks['AnalysisSpectrum'] = currentMap
  loadMaps['ANA3.exo-AnalysisSpectrum'] = currentMap
  currentMap['tag'] = 'ANA3.exo-AnalysisSpectrum'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00006'
  currentMap['name'] = 'AnalysisSpectrum'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnalysisSpectrum
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(globalMap.get('NMR').get('exolinks'))

  # Out-of-package link to AnnotationSetting
  currentMap = {}
  exolinks['AnnotationSetting'] = currentMap
  loadMaps['ANA3.exo-AnnotationSetting'] = currentMap
  currentMap['tag'] = 'ANA3.exo-AnnotationSetting'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00003'
  currentMap['name'] = 'AnnotationSetting'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AnnotationSetting
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to AtomSetMapping
  currentMap = {}
  exolinks['AtomSetMapping'] = currentMap
  loadMaps['ANA3.exo-AtomSetMapping'] = currentMap
  currentMap['tag'] = 'ANA3.exo-AtomSetMapping'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:56_00003'
  currentMap['name'] = 'AtomSetMapping'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AtomSetMapping
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037'))

  # Out-of-package link to AxisMapping
  currentMap = {}
  exolinks['AxisMapping'] = currentMap
  loadMaps['ANA3.exo-AxisMapping'] = currentMap
  currentMap['tag'] = 'ANA3.exo-AxisMapping'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00009'
  currentMap['name'] = 'AxisMapping'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.AxisMapping
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(globalMap.get('NMR').get('exolinks'))
  aList.append(globalMap.get('ANAW').get('exolinks'))
  aList.append(globalMap.get('ANAW').get('exolinks'))

  # Out-of-package link to ChainMapping
  currentMap = {}
  exolinks['ChainMapping'] = currentMap
  loadMaps['ANA3.exo-ChainMapping'] = currentMap
  currentMap['tag'] = 'ANA3.exo-ChainMapping'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:56_00001'
  currentMap['name'] = 'ChainMapping'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.ChainMapping
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033'))

  # Out-of-package link to PeakListView
  currentMap = {}
  exolinks['PeakListView'] = currentMap
  loadMaps['ANA3.exo-PeakListView'] = currentMap
  currentMap['tag'] = 'ANA3.exo-PeakListView'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00025'
  currentMap['name'] = 'PeakListView'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.PeakListView
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(globalMap.get('NMR').get('exolinks'))
  aList.append(globalMap.get('ANAW').get('exolinks'))
  aList.append(globalMap.get('ANAY').get('exolinks'))
  aList.append(globalMap.get('ANA3').get('exolinks'))

  # Out-of-package link to PeakSetting
  currentMap = {}
  exolinks['PeakSetting'] = currentMap
  loadMaps['ANA3.exo-PeakSetting'] = currentMap
  currentMap['tag'] = 'ANA3.exo-PeakSetting'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00004'
  currentMap['name'] = 'PeakSetting'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.PeakSetting
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to PrintSetting
  currentMap = {}
  exolinks['PrintSetting'] = currentMap
  loadMaps['ANA3.exo-PrintSetting'] = currentMap
  currentMap['tag'] = 'ANA3.exo-PrintSetting'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:14_00005'
  currentMap['name'] = 'PrintSetting'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.PrintSetting
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to ResidueMapping
  currentMap = {}
  exolinks['ResidueMapping'] = currentMap
  loadMaps['ANA3.exo-ResidueMapping'] = currentMap
  currentMap['tag'] = 'ANA3.exo-ResidueMapping'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-12-01-15:00:56_00002'
  currentMap['name'] = 'ResidueMapping'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.ResidueMapping
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00037'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00033'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))

  # Out-of-package link to SpectrumMapping
  currentMap = {}
  exolinks['SpectrumMapping'] = currentMap
  loadMaps['ANA3.exo-SpectrumMapping'] = currentMap
  currentMap['tag'] = 'ANA3.exo-SpectrumMapping'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00008'
  currentMap['name'] = 'SpectrumMapping'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.SpectrumMapping
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(globalMap.get('NMR').get('exolinks'))
  aList.append(globalMap.get('ANAW').get('exolinks'))

  # Out-of-package link to SpectrumView
  currentMap = {}
  exolinks['SpectrumView'] = currentMap
  loadMaps['ANA3.exo-SpectrumView'] = currentMap
  currentMap['tag'] = 'ANA3.exo-SpectrumView'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00024'
  currentMap['name'] = 'SpectrumView'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.SpectrumView
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(globalMap.get('NMR').get('exolinks'))
  aList.append(globalMap.get('ANAW').get('exolinks'))
  aList.append(globalMap.get('ANAY').get('exolinks'))

  # Out-of-package link to StoredContour
  currentMap = {}
  exolinks['StoredContour'] = currentMap
  loadMaps['ANA3.exo-StoredContour'] = currentMap
  currentMap['tag'] = 'ANA3.exo-StoredContour'
  currentMap['type'] = 'exo'
  currentMap['guid'] = 'www.ccpn.ac.uk_Fogh_2011-11-16-17:07:15_00003'
  currentMap['name'] = 'StoredContour'
  currentMap['eType'] = 'cplx'
  currentMap['class'] = ccpnmr.api.AnalysisV3.StoredContour
  aList = list()
  currentMap['keyMaps'] = aList
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2008-06-30-16:30:50_00001'))
  aList.append(globalMap.get('NMR').get('exolinks'))
  aList.append(mapsByGuid.get('www.ccpn.ac.uk_Fogh_2006-08-16-14:22:53_00032'))
