<SML> 0.24

#=======================================================================
#             	name     convention
<ResidueDef>  	CA2P     INTERNAL_1
#=======================================================================
    commonName = 'CA2P'
    shortName  = 'CA2P'
    comment    = 'Calcium 2plus ion'
    nameDict   = {'CCPN': 'other Ca neutral', 'INTERNAL_0': 'CA2P', 'BMRBd': None, 'CYANA': 'ION', 'CYANA2': 'ION', 'INTERNAL_1': 'CA2P', 'IUPAC': 'CA', 'AQUA': 'CA', 'PDB': 'CA', 'XPLOR': 'CA2'}
    properties = ['ion', 'metal', 'charged']

    dihedrals  = <NTlist>
    #---------------------------------------------------------------
    <DihedralDef> LB
    #---------------------------------------------------------------
        atoms    = [(-1, 'Q2'), (0, 'Q3'), (0, 'Q1'), (0, 'Q2')]
        karplus  = None
    </DihedralDef>
    </NTlist>

    atoms      = <NTlist>
    #---------------------------------------------------------------
    <AtomDef> CA
    #---------------------------------------------------------------
        topology   = []
        real       = []
        pseudo     = None
        nameDict   = {'INTERNAL_0': 'CA2P', 'BMRBd': None, 'CYANA': 'ME', 'CYANA2': 'ME', 'INTERNAL_1': 'CA', 'IUPAC': 'CA', 'AQUA': 'CA', 'PDB': 'CA', 'XPLOR': 'CA+2'}
        aliases    = ['CA', 'ME']
        type       = None
        spinType   = '45Ca'
        shift      = None
        hetatm     = True
        properties = ['isNotProton', 'notproton', 'isNotCarbon', 'notcarbon', 'isNotNitrogen', 'notnitrogen', 'isNotSulfur', 'isNotSulphur', 'notsulfur', 'notsulphur', 'isSidechain', 'sidechain', 'isNotAromatic', 'notaromatic', 'isNotMethyl', 'notmethyl', 'isNotMethylProton', 'notmethylproton', 'isNotPseudoAtom', 'notpseudoatom', 'hasNoPseudoAtom', 'hasnopseudoatom', 'isNotMethylene', 'notmethylene', 'isNotMethyleneProton', 'notmethyleneproton']
    </AtomDef>
    #---------------------------------------------------------------
    <AtomDef> Q3
    #---------------------------------------------------------------
        topology   = []
        real       = []
        pseudo     = None
        nameDict   = {'INTERNAL_0': 'Q3', 'BMRBd': None, 'CYANA': 'Q3', 'CYANA2': 'Q3', 'INTERNAL_1': 'Q3', 'IUPAC': None, 'AQUA': None, 'PDB': None, 'XPLOR': None}
        aliases    = []
        type       = 'PSEUD'
        spinType   = '1H'
        shift      = None
        hetatm     = False
        properties = ['isProton', 'proton', 'isNotCarbon', 'notcarbon', 'isNotNitrogen', 'notnitrogen', 'isNotSulfur', 'isNotSulphur', 'notsulfur', 'notsulphur', 'isSidechain', 'sidechain', 'isNotAromatic', 'notaromatic', 'isNotMethyl', 'notmethyl', 'isNotMethylProton', 'notmethylproton', 'isPseudoAtom', 'pseudoatom', 'hasNoPseudoAtom', 'hasnopseudoatom', 'isNotMethylene', 'notmethylene', 'isNotMethyleneProton', 'notmethyleneproton', 'isNotPseudoAtom', 'notpseudoatom']
    </AtomDef>
    #---------------------------------------------------------------
    <AtomDef> Q3'
    #---------------------------------------------------------------
        topology   = []
        real       = []
        pseudo     = None
        nameDict   = {'INTERNAL_0': "Q3'", 'BMRBd': None, 'CYANA': "Q3'", 'CYANA2': "Q3'", 'INTERNAL_1': "Q3'", 'IUPAC': None, 'AQUA': None, 'PDB': None, 'XPLOR': None}
        aliases    = []
        type       = 'PSEUD'
        spinType   = '1H'
        shift      = None
        hetatm     = False
        properties = ['isProton', 'proton', 'isNotCarbon', 'notcarbon', 'isNotNitrogen', 'notnitrogen', 'isNotSulfur', 'isNotSulphur', 'notsulfur', 'notsulphur', 'isSidechain', 'sidechain', 'isNotAromatic', 'notaromatic', 'isNotMethyl', 'notmethyl', 'isNotMethylProton', 'notmethylproton', 'isPseudoAtom', 'pseudoatom', 'hasNoPseudoAtom', 'hasnopseudoatom', 'isNotMethylene', 'notmethylene', 'isNotMethyleneProton', 'notmethyleneproton', 'isNotPseudoAtom', 'notpseudoatom']
    </AtomDef>
    #---------------------------------------------------------------
    <AtomDef> Q1
    #---------------------------------------------------------------
        topology   = []
        real       = []
        pseudo     = None
        nameDict   = {'INTERNAL_0': 'Q1', 'BMRBd': None, 'CYANA': 'Q1', 'CYANA2': 'Q1', 'INTERNAL_1': 'Q1', 'IUPAC': None, 'AQUA': None, 'PDB': None, 'XPLOR': None}
        aliases    = []
        type       = 'PSEUD'
        spinType   = '1H'
        shift      = None
        hetatm     = False
        properties = ['isProton', 'proton', 'isNotCarbon', 'notcarbon', 'isNotNitrogen', 'notnitrogen', 'isNotSulfur', 'isNotSulphur', 'notsulfur', 'notsulphur', 'isSidechain', 'sidechain', 'isNotAromatic', 'notaromatic', 'isNotMethyl', 'notmethyl', 'isNotMethylProton', 'notmethylproton', 'isPseudoAtom', 'pseudoatom', 'hasNoPseudoAtom', 'hasnopseudoatom', 'isNotMethylene', 'notmethylene', 'isNotMethyleneProton', 'notmethyleneproton', 'isNotPseudoAtom', 'notpseudoatom']
    </AtomDef>
    #---------------------------------------------------------------
    <AtomDef> Q1'
    #---------------------------------------------------------------
        topology   = []
        real       = []
        pseudo     = None
        nameDict   = {'INTERNAL_0': "Q1'", 'BMRBd': None, 'CYANA': "Q1'", 'CYANA2': "Q1'", 'INTERNAL_1': "Q1'", 'IUPAC': None, 'AQUA': None, 'PDB': None, 'XPLOR': None}
        aliases    = []
        type       = 'PSEUD'
        spinType   = '1H'
        shift      = None
        hetatm     = False
        properties = ['isProton', 'proton', 'isNotCarbon', 'notcarbon', 'isNotNitrogen', 'notnitrogen', 'isNotSulfur', 'isNotSulphur', 'notsulfur', 'notsulphur', 'isSidechain', 'sidechain', 'isNotAromatic', 'notaromatic', 'isNotMethyl', 'notmethyl', 'isNotMethylProton', 'notmethylproton', 'isPseudoAtom', 'pseudoatom', 'hasNoPseudoAtom', 'hasnopseudoatom', 'isNotMethylene', 'notmethylene', 'isNotMethyleneProton', 'notmethyleneproton', 'isNotPseudoAtom', 'notpseudoatom']
    </AtomDef>
    #---------------------------------------------------------------
    <AtomDef> Q2
    #---------------------------------------------------------------
        topology   = []
        real       = []
        pseudo     = None
        nameDict   = {'INTERNAL_0': 'Q2', 'BMRBd': None, 'CYANA': 'Q2', 'CYANA2': 'Q2', 'INTERNAL_1': 'Q2', 'IUPAC': None, 'AQUA': None, 'PDB': None, 'XPLOR': None}
        aliases    = []
        type       = 'PSEUD'
        spinType   = '1H'
        shift      = None
        hetatm     = False
        properties = ['isProton', 'proton', 'isNotCarbon', 'notcarbon', 'isNotNitrogen', 'notnitrogen', 'isNotSulfur', 'isNotSulphur', 'notsulfur', 'notsulphur', 'isSidechain', 'sidechain', 'isNotAromatic', 'notaromatic', 'isNotMethyl', 'notmethyl', 'isNotMethylProton', 'notmethylproton', 'isPseudoAtom', 'pseudoatom', 'hasNoPseudoAtom', 'hasnopseudoatom', 'isNotMethylene', 'notmethylene', 'isNotMethyleneProton', 'notmethyleneproton', 'isNotPseudoAtom', 'notpseudoatom']
    </AtomDef>
    #---------------------------------------------------------------
    <AtomDef> Q2'
    #---------------------------------------------------------------
        topology   = []
        real       = []
        pseudo     = None
        nameDict   = {'INTERNAL_0': "Q2'", 'BMRBd': None, 'CYANA': "Q2'", 'CYANA2': "Q2'", 'INTERNAL_1': "Q2'", 'IUPAC': None, 'AQUA': None, 'PDB': None, 'XPLOR': None}
        aliases    = []
        type       = 'PSEUD'
        spinType   = '1H'
        shift      = None
        hetatm     = False
        properties = ['isProton', 'proton', 'isNotCarbon', 'notcarbon', 'isNotNitrogen', 'notnitrogen', 'isNotSulfur', 'isNotSulphur', 'notsulfur', 'notsulphur', 'isSidechain', 'sidechain', 'isNotAromatic', 'notaromatic', 'isNotMethyl', 'notmethyl', 'isNotMethylProton', 'notmethylproton', 'isPseudoAtom', 'pseudoatom', 'hasNoPseudoAtom', 'hasnopseudoatom', 'isNotMethylene', 'notmethylene', 'isNotMethyleneProton', 'notmethyleneproton', 'isNotPseudoAtom', 'notpseudoatom']
    </AtomDef>
    </NTlist>
</ResidueDef>
#=======================================================================
</SML>
