
substituentInfo = {
 # TODO: good place to get short codes from? ChEBI?
  
  # Monovalent substituents
 'acetyl':            {'bondType': 'single', 'stereochem': None, 'shortCode': 'Ac',      'formula': 'COCH3'}, 
 'bromo':             {'bondType': 'single', 'stereochem': None, 'shortCode': 'Br',      'formula': 'Br'}, 
 'chloro':            {'bondType': 'single', 'stereochem': None, 'shortCode': 'Cl',      'formula': 'Cl'}, 
 'ethyl':             {'bondType': 'single', 'stereochem': None, 'shortCode': 'Eth',     'formula': 'CH2CH3'}, 
 'ethanolamine':      {'bondType': 'single', 'stereochem': None, 'shortCode': 'EtOAm',   'formula': 'CH2NHCH2OH'}, 
 'flouro':            {'bondType': 'single', 'stereochem': None, 'shortCode': 'F',       'formula': 'F'}, 
 'formyl':            {'bondType': 'single', 'stereochem': None, 'shortCode': 'For',     'formula': 'CHO'}, 
 'glycolyl':          {'bondType': 'single', 'stereochem': None, 'shortCode': 'Glycol',  'formula': 'COCH2OH'}, 
 'hydroxymethyl':     {'bondType': 'single', 'stereochem': None, 'shortCode': 'MeOH',    'formula': 'CH2OH'}, 
 'imino':             {'bondType': 'double', 'stereochem': None, 'shortCode': 'NH',      'formula': 'NH'}, 
 'iodo':              {'bondType': 'single', 'stereochem': None, 'shortCode': 'Im',      'formula': 'I'}, 
 '(r)-lactate':       {'bondType': 'single', 'stereochem': None, 'shortCode': 'R-Lac',   'formula': 'CH3CHCOOH'}, 
 '(s)-lactate':       {'bondType': 'single', 'stereochem': None, 'shortCode': 'S-Lac',   'formula': 'CH3CHCOOH'}, 
 'methyl':            {'bondType': 'single', 'stereochem': None, 'shortCode': 'Me',      'formula': 'CH3'}, 
 'n':                 {'bondType': 'single', 'stereochem': None, 'shortCode': 'N',       'formula': 'NH2'}, 
 'n-acetyl':          {'bondType': 'single', 'stereochem': None, 'shortCode': 'NAc',     'formula': 'NHCOCH3'}, 
 'n-alanine':         {'bondType': 'single', 'stereochem': None, 'shortCode': 'NAla',    'formula': 'NHCOCHNH2CH3'}, 
 'n-dimethyl':        {'bondType': 'single', 'stereochem': None, 'shortCode': 'NMe2',    'formula': 'N(CH3)2'}, 
 'n-formyl':          {'bondType': 'single', 'stereochem': None, 'shortCode': 'NFor',    'formula': 'NHCHO'}, 
 'n-glycolyl':        {'bondType': 'single', 'stereochem': None, 'shortCode': 'NGlycol', 'formula': 'NCOCH2OH'}, 
 'n-methyl':          {'bondType': 'single', 'stereochem': None, 'shortCode': 'NMe',     'formula': 'NHCH3'}, 
 'n-succinate':       {'bondType': 'single', 'stereochem': None, 'shortCode': 'NSuc',    'formula': 'NCOCH2CH2COOH'}, 
 'n-sulfate':         {'bondType': 'single', 'stereochem': None, 'shortCode': 'NSO3',    'formula': 'NHSO3H'}, 
 'n-triflouroacetyl': {'bondType': 'single', 'stereochem': None, 'shortCode': 'NAcF3',   'formula': 'NHCOCF3'}, 

 'nitrate':           {'bondType': 'single', 'stereochem': None, 'shortCode': 'NO2',     'formula': 'NO2'}, 
 'phosphate':         {'bondType': 'single', 'stereochem': None, 'shortCode': 'P',       'formula': 'PO3H2'},  # Note; was originally phospate
 'pyruvate':          {'bondType': 'single', 'stereochem': None, 'shortCode': 'Pyr',     'formula': 'COCOCH3'}, 
 'sulfate':           {'bondType': 'single', 'stereochem': None, 'shortCode': 'SO3',     'formula': 'SO3H'}, 
 'thio':              {'bondType': 'single', 'stereochem': None, 'shortCode': 'S',       'formula': 'SH'}, 
 
  # Divalent substituents 
 '(r)-pyruvate':      {'bondType': 'single', 'stereochem': None, 'shortCode': 'R-Pyr',   'formula': 'CH2CCOOH'}, 
 '(s)-pyruvate':      {'bondType': 'single', 'stereochem': None, 'shortCode': 'S-Pyr',   'formula': 'CH2CCOOH'}, 
 #'(r)-lactate': {'bondType': 'single', stereochem: None, 'shortCode': 'R-Lac', formula: 'CH3CHCO'}, 
 #'(s)-lactate': {'bondType': 'single', stereochem: None, 'shortCode': 'S-Lac', formula: 'CH3CHCO'}, 


  # NOT YET IN EUROCARB-DB!
 'methoxy':           {'bondType': 'single', 'stereochem': None, 'shortCode': 'OMe',     'formula': 'OCH3'}, 

}
